更新日志
********


Python 下一版
=============

*发布日期: XXXX-XX-XX*


Windows
-------

* gh-149786: 修复 Windows 自由线程构建上虚拟环境启动器的问题。

* gh-124111: 更新 Windows 构建以使用 Tcl/Tk 9.0.3。

* gh-138489: Windows 发行版现在包括一个 "build-details.json" 文件 (参
  见 **PEP 739**)。 旧式安装程序不会安装它，但其他所有来自 python.org
  的发行版和 "PC\layout" 脚本中所有预设配置都会包括它。


测试
----

* gh-149776: 在 Linux 内核 7.1 或更新版本上修复 test_socket。 在不支持
  的情况下跳过 UDP Lite 测试。 由 Victor Stinner 编写补丁。.


安全性
------

* gh-149698: 将捆绑的 libexpat 更新至 version 2.8.1 以修复 **CVE
  2026-45186**。

* gh-87451: "ftplib" 模块的未写入文档的 "ftpcp" 函数默认将不再信任作为
  对 "PASV" 命令的响应从源服务器返回的 IPv4 地址，以完成对
  CVE-2021-4189 的修复。 对于 "ftplib.FTP"，之前的行为可通过将源
  "ftplib.FTP" 实例上的 "trust_server_pasv_ipv4_address" 属性设为
  "True" 来重新启用。 感谢 Aurascape AI 的 Qi Deng 报告此问题。

* gh-149474: 修复在创建输出文件时 "profiling.sampling" 中的二进制写入
  器不发出审计事件的问题 (**PEP 578**)。 该写入器和读取器现在将可接受
  任意路径型对象。 由 Maurycy Pawłowski-Wieroński 编写补丁。

* gh-149486: 现在 "tarfile.data_filter()" 会使用与写入磁盘的相同的正规
  化值来验证链接目标，当解析符号链接目录时将去除成员名称末尾的分隔符，
  并会拒绝将替换目标目录本身的链接成员。 这将关闭  "data" 提取过滤器的
  几个路径遍历绕过漏洞。

* gh-149018: Improved protection against XML hash-flooding attacks in
  "xml.parsers.expat" and "xml.etree.ElementTree" when Python is
  compiled with libExpat 2.8.0 or later.


库
--

* gh-149980: Fix "tarfile" so that GNU long-name directory entries
  have all trailing slashes stripped from their names, matching the
  behavior for short-name entries.  Previously, only a single trailing
  slash was removed.

* gh-146452: Fix race condition when pickling dictionaries in free
  threaded builds. Also reduce critical section cover.

* gh-79413: Update "dataclasses.make_dataclass()" to add a *qualname*
  parameter. The *qualname* parameter will be used to set the
  "__qualname__" of the created "dataclass".

* gh-149921: 修复 "_interpchannels" 和 "_interpqueues" 扩展模块错误路
  径中的引用泄漏问题。

* gh-142349: 将 "lazy" 添加至 "help()" 的支持主题列表中。

* gh-149816: Fix a race condition in "_random.Random.__init__" method
  in free-threading mode.

* gh-149801: 为对应的编解码器增加具有前导零加数字形式的 IANA 注册名和
  别名（如 IBM00858, CP00858, IBM01140, CP01140）。

* gh-149720: Remove support for undotted *ext* in
  "mimetypes.MimeTypes.add_type()".

* gh-149718:在 Tachyon 中凝聚连续的相同栈帧，以便聚合采集器（pstats、
  collapsed、flamegraph、gecko）接收一个采集项。 采样率将获得 3x 提升
  ，错误率和漏检率将下降 70%。 由 Maurycy Pawłowskii-Wieroński 编写补
  丁。

* gh-149701: 修复在禁用哈希时来自 Lib/venv/bin/activate 不正确的返回码

* gh-149504: 修正 "site.addsitedir()" 以允许来自启动文件内部的重进入调
  用。 在此之前，包含调用了 "site.addsitedir()" 的 "import" 行的
  ".pth" 文件（或执行相同操作的 ".start" 入口点）可能会在站点初始化期
  间崩溃并引发 "RuntimeError: dictionary changed size during
  iteration"，从而破坏 "uv run --with" 等工具的执行。

* gh-149634: Remove deprecated and unused "tarfile.TarInfo.tarfile"
  attribute.

* gh-139489: 将 "xml.is_valid_text()" 添加至 "xml.__all__"。

* gh-149614: 修复一个可能破坏对 "argparse.ArgumentParser" 实例进行深拷
  贝的能力的回归问题。

* gh-149600: Remove deprecated "asyncio.iscoroutinefunction()"
  function.

* gh-149598: Remove support of deprecated *strm* argument for
  "logging" handlers.

* gh-149595: Remove the "sys._enablelegacywindowsfsencoding()"
  function which has been deprecated since Python 3.13.

* gh-149567: Remove the "shutil.ExecError" exception which has been
  deprecated since Python 3.14.

* gh-112821: 在 REPL 中，自动补全可能会运行描述器的 getter 中的任意代
  码。 如果 getter 引发了异常，自动补全将无法为整个对象提供任何选项。
  现在自动补全的工作方式将能符合预期。

* gh-149436: Improve performance of "inspect.getattr_static()".

* gh-149537: Remove kw parameters from python version of
  "functools.reduce()" function.

* gh-149530: Removed "symtable.Class.get_methods()" which has been
  deprecated since 3.14.

* gh-149528: Remove "annotationlib.ForwardRef._evaludate" deprecated
  method.

* gh-149388: 使 "asyncio.windows_utils.PipeHandle" 关闭幂等。

* gh-149499: Removed the "sysconfig.expand_makefile_vars()" function
  which has been deprecated since Python 3.14. Use the "vars" argument
  of "sysconfig.get_paths()" instead.

* gh-149464: Add "os.pidfd_getfd()" for duplicating a file descriptor
  from another process via a pidfd.  Available on Linux 5.6+. Patch by
  Maurycy Pawłowski-Wieroński.

* gh-148441: "xml.parsers.expat": 防止 "CharacterDataHandler()" 中当字
  符数据大小超出解析器的 "缓冲区大小" 时发生崩溃。

* gh-146452: Fix segfault in "pickle" when pickling a dictionary
  concurrently mutated by another thread in the free-threaded build.

* gh-140924: Add "locale.localize()", "locale.delocalize()" and
  platform-specific locale constants from the "_locale" module to
  "locale.__all__".

* gh-140344: The classes "ast.slice", "ast.ExtSlice", "ast.Index",
  "ast.Suite", "ast.AugLoad", "ast.AugStore", and "ast.Param",
  deprecated since Python 3.9, now issue deprecation warnings on use.
  They are now scheduled for removal in Python 3.21.

  The "dims" property of "ast.Tuple" objects, deprecated since Python
  3.9, now issues a deprecation warning when accessed. The property is
  scheduled for removal in Python 3.21. Use the (non-deprecated)
  "elts" property of "ast.Tuple" objects instead.

  The deprecated global names are also no longer imported by "from ast
  import *".

* gh-86533: The "os.makedirs()" function and "pathlib.Path.mkdir()"
  method now have a *parent_mode* parameter to specify the mode for
  intermediate directories when creating parent directories. This
  allows one to match the behavior from Python 3.6 and earlier for
  "os.makedirs()".

* gh-128110: Fix bug in the parsing of "email" address headers that
  could result in extraneous spaces in the decoded text when using a
  modern email policy. Space between pairs of adjacent **RFC 2047**
  encoded-words is now ignored, per section 6.2 (and consistent with
  existing parsing of unstructured headers like *Subject*).

* bpo-45509: 现在会检查 Gzip 标头中损坏的 NAME, COMMENT 和 HCRC 字段。


核心与内置函数
--------------

* gh-149590: Fix crash when faulthandler is imported more than once.

* gh-138325: Speed up converting a list to a tuple in the
  "tuple(genexpr)" fast path and in starred tuple displays (e.g. "(*a,
  *b)") by stealing the list's items into the tuple instead of copying
  them.

* gh-149816: Fix a race condition in "_PyBytes_FromList" in free-
  threading mode.

* gh-149816: Fix a race condition in "memoryview" with free-threading.

* gh-139808: Add branch protections for AArch64 (BTI/PAC) in assembly
  code used by "-X perf_jit" (Linux perf profiler integration).

* gh-149676: 修复 "frozendict | frozendict" 的哈希问题。

* gh-149642:在 "PYTHON_LAZY_IMPORTS=all" 的情况下允许在函数中的
  "exec()" 调用内部执行导入。

* gh-144957: 修复由模块级 "__getattr__" 提供的模块属性的惰性 "from" 导
  入。imports of module attributes provided by module-level.

* gh-149459: 修复在插入合成 "NULL" 栈条目后对专门的 "LOAD_SPECIAL" 守
  卫项执行去优化时 JIT 优化器中的崩溃问题。

* gh-75723: Avoid re-executing ".pth" files when "site.addsitedir()"
  is called for a known directory.


C API
-----

* gh-149725:增加 "PySentinel_CheckExact()" 用于准确的 "sentinel" 类型
  测试以配合现有的 "PySentinel_Check()"。

* gh-145235: 使 "PyDict_AddWatcher()", "PyDict_ClearWatcher()",
  "PyDict_Watch()" 和 "PyDict_Unwatch()" 在 *自由线程* 构建版上是线程
  安全的。


构建
----

* gh-115119: Removed bundled copy of the libmpdec, use system library
  if it's available. Patch by Sergey B Kirpichev.


Python 3.15.0 beta 1
====================

*发布日期: 2026-05-07*


安全性
------

* gh-149254: 更新 Android 和 iOS 安装程序以使用 OpenSSL 3.5.6。

* gh-149017: 将捆绑的 libexpat 更新至 2.8.0。

* gh-148252: 修复在 32 位构建版上解码某些 ".pyb" 输入时
  "_remote_debugging" 中的字符串表和样本记录边界检查问题。 由 Maurycy
  Pawłowski-Wieroński 编写补丁。

* gh-90309: 在使用 "http.cookies.BaseCookie.js_output()" 将 cookie 嵌
  入到 JavaScript 时会对值执行 base64 编码以避免注入和转义。

* gh-148808: 在将 "nbytes" 形参用于
  "asyncio.AbstractEventLoop.sock_recvfrom_into()" 时会添加缓冲区边界
  检测。 仅对 Windows 和 "asyncio.ProactorEventLoop" 有意义。

* gh-148395: 修复 "lzma.LZMADecompressor", "bz2.BZ2Decompressor" 和内
  部 "zlib._ZlibDecompressor" 中当内存分配失败引发 "MemoryError" 时的
  悬空输入指针问题，这可能导致后续的 "decompress()" 调用通过旧指针读取
  或写入已经被释放的调用方缓冲区。

* gh-148252: 修复在 32 位构建版上解码某些 ".pyb" 输入时Fixed stack
  depth calculation in "_remote_debugging" 中的栈深度计算问题。 该问题
  最初由 Tristan Madani (GitHub 上的 @TristanInSec) 标识并诊断。

* gh-148178: 通过在使用之前先验证远程调试偏移表以确定内存读取量或解读
  远程布局对 "_remote_debugging" 进行加固。

* gh-148169: "webbrowser" 中的一个旁路允许以 "%action" 为前缀的 URL 通
  过横线前缀安全检查。

* gh-146581: 修正 Windows 上 "shutil.unpack_archive()" 中有关 ZIP 文件
  的漏洞，如果归档中的补丁包含 Windows 驱动器前缀则该漏洞允许在目标树
  之外写入文件。 现在此类无效路径将被跳过。 名称中包含 ".." 的文件（如
  "foo..bar"）不再会被跳过。

* gh-137586: 修复在 macOS 上 "webbrowser" 中的 PATH 注入安全漏洞，即不
  带绝对路径地唤起 "osascript"。 新的 "MacOS" 类将直接使用
  "/usr/bin/open"，完全消除对 "osascript" 的依赖。

* gh-146333: 修复 "configparser.RawConfigParser" 选项解析正则表达式
  ("OPTCRE" and "OPTCRE_NV") 中的二次方级回溯问题。 精心设计有大量空格
  符的配置行可能导致过量的 CPU 使用。

* gh-146211: 在 HTTPConnection.set_tunnel() 方法的隧道请求头中拒绝
  CR/LF 字符。


核心与内置函数
--------------

* gh-148940: Revert the process size based deferral of garbage
  collection (gh-133464). The performance issue this change resolves
  is also fixed by gh-142562.  This approach has the problem that
  process size as seen by the OS (e.g. the resident size or RSS) does
  not immediately decrease after cyclic garbage is freed since
  mimalloc defers returning memory of the OS. This change applies to
  the free-threaded GC only.

* gh-149243: Check for recursion limits in "CALL_ALLOC_AND_ENTER_INIT"
  opcode.

* gh-126910: Add support for unwinding JIT frames using GNU backtrace.
  Patch by Diego Russo and Pablo Galindo

* gh-149171: 允许对 "typing.TypeAliasType" 实例的 "__module__" 属性赋
  值。

* gh-149122: 修正在对传入异步生成器表达式参数的 "all()", "any()",
  "tuple()", "list()" 和 "set()" 的优化调用中发生崩溃的问题 (例如
  "tuple(await x for x in y)")。 这些调用现在能正确地引发 "TypeError"
  而不会发生崩溃。

* gh-149049: 修复第 2 层中 "BINARY_OP" 的栈下溢问题。

* gh-83065: Fix a deadlock that could occur when one thread is
  importing a submodule (for example "import pkg.sub.mod") while
  another thread is importing one of its parent packages (for example
  "import pkg.sub") and that parent's "__init__.py" itself imports the
  submodule. The import system now acquires module locks in
  hierarchical (parent-before-child) order so the two threads
  serialise instead of raising "_DeadlockError".

* gh-113956: 修复自由线程构建版中 "sys.intern()" 在内化其他线程所拥有
  的字符串时的数据竞争问题。 当把原始对象设为永生对象不安全时将改用当
  前线程所拥有的内化副本。

* gh-148850: 修复 "os.getrandom()" 中内存净化器的假阳性问题。

* gh-148820: 修复自由线程构建版中 "_PyRawMutex" 当从
  "_PySemaphore_Wait" 返回 "Py_PARK_INTR" 时可能会让等待方在解锁线程的
  "_PySemaphore_Wakeup" 完成之前销毁其信号，导致致命
  "ReleaseSemaphore" 错误的竞争问题。

* gh-148829: 增加 "sentinel"，实现 **PEP 661**。 PEP 由 Tal Einat 撰写
  ；由 Jelle Zijlstra 提供补丁。

* gh-146270: 修复 "structmember.c" 中的序列一致性程序缺陷。

* gh-148766: 解释器帮助 (如 "python --help") 现在支持彩色。 由 Hugo
  van Kemenade 编写补丁。

* gh-148571: 修复在专门的操作码族继承了不兼容的已记录操作数布局时 JIT
  优化器中的崩溃问题。

* gh-148653: Forbid "marshalling" recursive code objects, "slice" and
  "frozendict" objects which cannot be correctly unmarshalled.

* gh-142516: Forward-port the generational cycle garbage collector to
  the default 3.15 build, replacing the incremental collector while
  leaving the free-threaded collector unchanged.

* gh-146462: Added "PyTypeObject.tp_basicsize",
  "PyTypeObject.tp_dictoffset", and "PyHeapTypeObject.ht_cached_keys"
  offsets to "_Py_DebugOffsets" to support version-independent read-
  only dict introspection tools.

* gh-145239: Unary plus is now accepted in "match" literal patterns,
  mirroring the existing support for unary minus. Patch by Bartosz
  Sławecki.

* gh-148515: Fix a bug in the JIT optimizer reading operands for uops
  with multiple caches.

* gh-148390: 修正当在 "cast()" 中使用原生布尔格式 ("?") 时
  "memoryview" 中的未定义行为。 在之前版本中，在某些常见平台上，调用
  "memoryview(b).cast("?").tolist()" 对于任意偶数字节值 *b* 会不正确地
  返回 "[False]" 而不是 "[True]"。 由 Bénédikt Tran 编写补丁。

* gh-148418: 修复损坏的 "TYPE_CODE" marshal 流中可能出现的引用泄漏问题
  。

* gh-148393: 修复 *free-threaded build* 中 "PyDict_Watch()" /
  "PyDict_Unwatch()" 与并发字典修改之间的数据竞争问题。

* gh-148398: Fix a bug in the JIT optimizer where class attribute
  loads were not invalidated after type mutation.

* gh-146527: Add a "GCMonitor" class with a "get_gc_stats" method to
  the "_remote_debugging" module to allow reading GC statistics from
  an external Python process without requiring the full
  "RemoteUnwinder" functionality. Patch by Sergey Miryanov and Pablo
  Galindo.

* gh-148284: 通过在带有计算跳转的编译时设置内联的函数限制修复 Python
  的解释器循环在 Clang 22 上过高的栈消耗问题。

* gh-148037: 在自由线程构建中移除 "PyCode_Addr2Line()" 的关键节。

* gh-115802: Improve JIT code generation on Linux AArch64 by reducing
  the indirect call to external symbols. Patch by Diego Russo.

* gh-148189: Repaired undercount of bytes in type-specific free lists
  reported by sys._debugmallocstats(). For types that participate in
  cyclic garbage collection, it was missing two pointers used by GC.

* gh-148222: 修复 "types.GenericAlias" 中当下层类型不支持 vectorcall
  协议时对 vectorcall 的支持。 修复 "types.GenericAlias" 和
  "types.UnionType" 中当发生内存错误时可能的泄漏问题。

* gh-148208: 修复 "PyObject_Print()" 中的递归深度泄漏问题。

* gh-95004: The specializing interpreter now specializes for
  "enum.Enum" improving performance and scaling in free-threading.
  Patch by Kumar Aditya.

* gh-149202: Enable frame pointers by default for GCC-compatible
  CPython builds, including "-mno-omit-leaf-frame-pointer", "-marm" on
  32-bit ARM, and/or "-mbackchain" on s390x platforms when the
  compiler supports them, so profilers and debuggers can unwind native
  interpreter frames more reliably. Users can pass "--without-frame-
  pointers" to "./configure" to opt out.

* gh-148014: Accept a function name in "-X presite" command line
  option and "PYTHON_PRESITE" environment variable. Patch by Victor
  Stinner.

* gh-147998: 修正解释器辅助调用中的内存泄漏以使在操作跨越解释器边界时
  清理过程可正常工作。 由 Maurycy Pawłowskii-Wieroński 编写补丁。

* gh-146455: 修正在将常量折叠从 AST 移至 CFG 优化器之后的 O(N²) 级编译
  时回归问题。

* gh-146306: Specialize float true division in the tier 2 optimizer
  with inplace mutation for uniquely-referenced operands.

* gh-142186: Global "sys.monitoring" events can now be turned on and
  disabled on a per code object basis. Returning "DISABLE" from a
  callback disables the event for the entire code object (for the
  current tool).

* gh-126910: Add support for unwinding JIT frames using GDB. Patch by
  Diego Russo and Pablo Galindo.

* gh-146031: The unstable API _PyInterpreterState_SetEvalFrameFunc has
  a companion function
  _PyInterpreterState_SetEvalFrameAllowSpecialization to specify if
  specialization should be allowed. When this option is set to 1 the
  specializer will turn Python -> Python calls into specialized
  opcodes which the replacement interpreter loop can choose to respect
  and perform inlined dispatch.

* gh-145278: The "encodings" is now partially frozen, including the
  "aliases" and "utf_8" submodules.

  The "linecache" is now frozen.

* gh-134584: Optimize and eliminate redundant ref-counting for
  "MAKE_FUNCTION" in the JIT.

* gh-143886: Reorder function annotations so positional-only arguments
  are returned before other arguments. This fixes how
  "functools.singledispatch()" registers functions with positional-
  only arguments.

* gh-98894: Restore "function__entry" and "function__return"
  DTrace/SystemTap probes that were broken since Python 3.11.

* gh-116021: Support for creating instances of abstract AST nodes from
  the "ast" module is deprecated and scheduled for removal in Python
  3.20. Patch by Brian Schubert.

* gh-137814: 修复在函数上应用 "__annotate__" 函数的 "__qualname__" 属
  性问题。

* gh-137600: "ast": The constructors of AST nodes now raise a
  "TypeError" when a required argument is omitted or when a keyword
  argument that does not map to a field on the AST node is passed.
  These cases had previously raised a "DeprecationWarning" since
  Python 3.13. Patch by Brian Schubert.

* gh-137293: 修复当在 "sys.remote_exec()" 中搜索 ELF 文件时的
  "SystemError"。

* gh-135357: Add support for "socket.SO_PASSRIGHTS" on Linux.

* gh-134690: Removed deprecated in **PEP 626** since Python 3.12
  "codeobject.co_lnotab" from "types.CodeType".

* gh-100239: Specialize "BINARY_OP" for concatenation of lists and
  tuples, and propagate the result type through "_BINARY_OP_EXTEND" in
  the tier 2 optimizer so that follow-up type guards can be
  eliminated.


库
--

* gh-148823: Defer the import of "_colorize" in "argparse" until
  needed for coloring output.

* gh-141560: Add an *annotation_format* parameter to
  "inspect.getfullargspec()".

* gh-139489: Add the "xml.is_valid_text()" function, which allows to
  check whether a string can be used in the XML document.

* gh-142389: Add backticks to stdlib argparse help to display in
  colour. Patch by Hugo van Kemenade.

* gh-149377: 将捆绑的 pip 更新至 26.1.1

* gh-142389: Add backtick markup support in "argparse" option help
  text to highlight inline code when color output is enabled. Patch by
  Hugo van Kemenade.

* gh-148675: Remove "F" and "D" formats from "array" and "memoryview".
  Patch by Victor Stinner.

* gh-149342: Fix "_remote_debugging" binary writing so that sampling a
  thread whose Python frame stack is empty (for example while it is in
  a C call or mid-syscall) no longer raises "RuntimeError("Invalid
  stack encoding type")", and so that "BinaryWriter.total_samples"
  after "finalize()" or context-manager exit includes samples flushed
  from the RLE buffer. Patch by Maurycy Pawłowski-Wieroński.

* gh-149010: The "inspect" module CLI now reports as much information
  as it has available for non-source modules when "--details" is
  specified, and provides an error message rather than a traceback
  when "--details" is omitted. It also reports improved information
  when the given target location is not the target's defining location
  and when the given target is a data value rather than a class or
  function definition.

* gh-146609: Use "argparse" for colour help "timeit" CLI. Patch by
  Hugo van Kemenade.

* gh-142389: Add backticks for colour to regrtest and pdb's help
  description. Patch by Hugo van Kemenade.

* gh-144384: Lazily import "_colorize". Patch by Hugo van Kemenade.

* gh-149321: Fix import cycles exposed by running standard library
  modules with "-X lazy_imports=none".

* gh-145378: Generate consistent colors for "pdb" commands in "pdb"
  REPL.

* gh-149296: Add a "dump" subcommand to "profiling.sampling" that
  prints a single traceback-style snapshot of a running process's
  Python stack, including per-thread status, source line highlighting,
  optional bytecode opcode names, and async-aware task reconstruction.
  Patch by Pablo Galindo.

* gh-143231: A *module* attribute has been added to
  "warnings.WarningMessage".

* gh-148675: "ctypes": Change the "_type_" of "c_float_complex",
  "c_double_complex" and "c_longdouble_complex" from "F", "D" and "G"
  to "Zf", "Zd" and "Zg" for compatibility with numpy. Patch by Victor
  Stinner.

* gh-148675: The "array.typecodes" type changed from "str" to "tuple"
  to support type codes longer than 1 character ("Zf" and "Zd"). Patch
  by Victor Stinner.

* gh-149221: 为 "random.binomialvariate()" 捕获罕见的 math 域错误。

* gh-149231: In "tomllib", the number of parts in TOML keys is now
  limited.

* gh-143231: "unittest.TestCase.assertWarns()" and
  "unittest.TestCase.assertWarnsRegex()" no longer swallow warnings
  that do not match the specified category or regex. Nested context
  managers are now supported.

* gh-149214: Fix "_remote_debugging" misreading non-ASCII Unicode
  strings (Latin-1, BMP and non-BMP) from a remote process. Filenames
  and function names that contain non-ASCII characters are now
  reported correctly in stack traces, the sampling profiler, and
  "asyncio" task introspection.

* gh-149189: "pprint" now uses modern defaults: "indent=4" and
  "width=88", and the default "compact=False" output is now formatted
  similar to pretty-printed "json.dumps()", with opening parentheses
  and brackets followed by a newline and the contents indented by one
  level. The *expand* parameter, added in 3.15.0a8, has been removed;
  "compact=False" (the default) now produces the former "expand=True"
  layout. Patch by Hugo van Kemenade.

* gh-149173: Fix inverted "PYTHON_BASIC_REPL" environment check in
  "pdb._pyrepl_available".

* gh-149117: 修复 "runpy.run_module()" 和 "runpy.run_path()" 以上它们
  引发的 "ImportError" 上设置 "name" 属性。

* gh-149148: "ensurepip": 将捆绑的 pip 升级至 26.1。 此版本修复了
  **CVE 2026-3219** 安全漏洞。 由 Victor Stinner 编写补丁。

* gh-149009: Validate that "profiling.sampling" binary profiles do not
  contain more unique (thread, interpreter) pairs than declared in the
  header. Patch by Maurycy Pawłowski-Wieroński.

* gh-148292: "ssl": Update "ssl.SSLSocket" and "ssl.SSLObject" for
  OpenSSL 4. The classes now remember if they get a "ssl.SSLEOFError".
  In this case, following "read()", "sendfile()", "write()", and
  "do_handshake()" calls raise "ssl.SSLEOFError" without calling the
  underlying OpenSSL function. Thanks to that, "ssl.SSLSocket" behaves
  the same on all OpenSSL versions on EOF.  Patch by Victor Stinner.

* gh-149085: Add a *max_threads* keyword argument to
  "faulthandler.dump_traceback()",
  "faulthandler.dump_traceback_later()", "faulthandler.enable()", and
  "faulthandler.register()".

* gh-148641: "pkgutil.resolve_name()" gets a new optional, keyword-
  only argument called "strict".  The default is "False" for backward
  compatibility.

* gh-148093: 修正 "binascii.a2b_uu()" 中越界读取一个字节的问题。 将会
  引发 "binascii.Error"，而不是超出缓冲区末尾继续读取。

* gh-149083: "dataclasses.MISSING" 和 "dataclasses.KW_ONLY" 现在是
  "sentinel" 的实例。

* gh-148914: 修正 "pickle" 的 Python 实现中带内 "PickleBuffer" 的记忆
  问题。 在此之前，相同的 "PickleBuffer" 不会保留标识，空的可写
  "PickleBuffer" 会记忆一个空的字节数组对象而不是 "b''"，因此对后续
  "b''" 的引用会被反 pickled 为一个空的字节数组对象。

* gh-149026: 为 "pickletools" CLI 输出增加色彩。 由 Hugo van Kemenade
  编写补丁。

* gh-148991: 为 "tokenize" CLI 输出增加色彩。 由 Hugo van Kemenade 编
  写补丁。

* gh-138907: 在 "urllib.robotparser" 中支持 **RFC 9309**。

* gh-148981: 为 "ast.dump()" 增加 *color* 形参。

* gh-148849: Deprecate "http.cookies.Morsel.js_output()" and
  "http.cookies.BaseCookie.js_output()", which will be removed in
  Python 3.19. Use "http.cookies.Morsel.output()" or
  "http.cookies.BaseCookie.output()" instead.

* gh-146311: Add a *canonical* keyword-only parameter to the base16,
  base32, base64, base85, ascii85, and Z85 decoders in "base64" and
  "binascii". When true, encodings with non-zero padding bits
  (base16/32/64) or non-canonical encodings (base85/ascii85) are
  rejected. Single-character final groups in "binascii.a2b_ascii85()"
  and "binascii.a2b_base85()" are now always rejected as encoding
  violations, regardless of *canonical*; previously they were silently
  ignored and produced no output bytes.

* gh-148947: 修复在 crash in "@dataclasses.dataclass" 设置
  "slots=True" 的情况下当类中的函数存在空的 "__class__" 单元时的崩溃问
  题。

* gh-148680: 在作为字符串被求值时包含内部名称以代表已知对象的
  "ForwardRef" 对象现在会显示已知对象的 "type_repr" 而不是内部的
  "__annotationlib_name_x__" 名称。

* gh-124397: The threading module added tooling to support concurrent
  iterator access: "threading.serialize_iterator",
  "threading.synchronized_iterator()", and
  "threading.concurrent_tee()".

* gh-148801: "xml.etree.ElementTree": 修复在深度嵌套树结构上
  "Element.__deepcopy__" 中发生崩溃的问题。

* gh-148735: "xml.etree.ElementTree": 修复了当搜索期间元素树被并发修改
  时 "Element.findtext" 的释放后被使用问题。

* gh-148740: 修复了 "uuid" 命令行界面的使用问题以支持为 uuid3 和 uuid5
  提供自定义命名空间。

* gh-148688: "bz2", "compression.zstd", "lzma", "zlib": Fix a double
  free on memory allocation failure. Patch by Victor Stinner.

* gh-148675: "array", "struct": Add support for "Zd" and "Zf" formats
  for double complex and float complex. Patch by Victor Stinner.

* gh-148651: 修复 "compression.zstd.ZstdDecompressor" 在传入无效选项键
  时的引用泄漏问题。

* gh-148641: **PEP 829** (package startup configuration files)
  implements a new format "<name>.start" parallel to "<name>.pth"
  files, to replace "import" lines in the latter.

* gh-148639: 实现 **PEP 800**，增加 "@typing.disjoint_base" 装饰器。
  由 Jelle Zijlstra 编写补丁。

* gh-148615: 修正 "pdb" 以接受标准的 -- 选项结束分隔符。 由 haampie 报
  告。 由 Shrey Naithani 编写补丁。

* gh-146553: 修复当 "__wrapped__" 构成回环时 "typing.get_type_hints()"
  中的无限循环问题。 由 Shamil Abdulaev 编写补丁。

* gh-148599: 更新 "socket" 模块的 WSA 错误消息以匹配官方文档。

* gh-148508: 当在 iOS 上运行 SSL 测试时发生间歇性定时错误的问题已被解
  决。

* gh-144881: "asyncio" debugging tools ("python -m asyncio ps" and
  "pstree") now retry automatically on transient errors that can occur
  when attaching to a process under active thread delegation. The
  number of retries can be controlled with the "--retries" flag. Patch
  by Bartosz Sławecki.

* gh-148518: 如果使用非 "compat32" 策略解析包含以起始双引号结尾的地址
  标头的电子邮件，则访问通过该标头对象访问的邮箱的 "username" 属性会导
  致 "IndexError"。 现在它可以正确地返回一个空字符串作为结果。

* gh-148464: 为 "c_float_complex" 和 "c_double_complex" 增加缺失的
  "__ctype_le/be__" 属性。 由 Sergey B Kirpichev 编写补丁。.

* gh-148370: "configparser": 防止当解析器解析多行内容失败引发
  "ParsingError" 时的平方级复杂度行为。 由 Bénédikt Tran 编写补丁。

* gh-121190: "importlib.resources.files()" now emits a more meaningful
  error message when module spec is None (as found in some "__main__"
  modules).

* gh-127012: "importlib.abc.Traversable.read_text" now allows/solicits
  an "errors" parameter.

* gh-137855: 通过惰性加载 "re" 和 "copy" 模块改善 "dataclasses" 模块的
  导入时间。

* gh-148352: 为 "calendar"'s CLI 输出添加更多色彩。 由 Hugo van
  Kemenade 编写补丁。

* gh-148254: 在 "timeit" 详细输出中使用单数形式 "sec" 而非 "secs" 以与
  其他时间单位保持一致。

* gh-130472: 导入补全集成到 fancycompleter。

* gh-148241: "json": Fix serialization: no longer call "str(obj)" on
  "str" subclasses. Patch by Victor Stinner.

* gh-148225: The "profiling.sampling" "replay" command now rejects
  non-binary profile files with a clear error explaining that replay
  only accepts files created with "--binary".

* gh-148192: 当行分隔符不为 n 时
  "email.generator.Generator._make_boundary" 可能无法检测重复的边界字
  符串。 现在它在行分隔符为 rn 时也能正确检测边界字符串。

* gh-148207: "typing.TypeVarTuple" now accepts "bound", "covariant",
  "contravariant", and "infer_variance" parameters, matching the
  interface of "typing.TypeVar" and "typing.ParamSpec".

* gh-148100: *Soft deprecate* "re.match()" and "re.Pattern.match()" in
  favour of "re.prefixmatch()" and "re.Pattern.prefixmatch()". Patch
  by Hugo van Kemenade.

* gh-147991: Improve "tomllib" import time (up to 10x faster). Patch
  by Victor Stinner.

* gh-147957: Guarantees that "collections.UserDict.popitem()" will pop
  in the same order as the wrapped dictionary rather than an arbitrary
  order.

* gh-146256: The "profiling.sampling" module now supports JSONL output
  format via "--jsonl". Each run emits a newline-delimited JSON file
  that is sequentially parseable by external tools, scripts, and
  programmatic consumers. Patch by Maurycy Pawłowski-Wieroński.

* gh-146609: Add colour to "timeit" CLI output. Patch by Hugo van
  Kemenade.

* gh-146563: "xml.parsers.expat": add an exception note when a custom
  Expat handler return value cannot be properly interpreted. Patch by
  Bénédikt Tran.

* gh-137586: Add "MacOS" to "webbrowser" for macOS, which opens URLs
  via "/usr/bin/open" instead of piping AppleScript to "osascript".
  Deprecate "MacOSXOSAScript" in favour of "MacOS".

* gh-146406: Cross-language method suggestions are now shown for
  "AttributeError" on builtin types and their subclasses. For example,
  "[].push()" suggests "append", "(1,2).append(3)" suggests using a
  "list", "None.keys()" suggests expecting a "dict", and "1.0.__or__"
  suggests using an "int".

* gh-146313: 修复 "multiprocessing" 的资源跟踪器中死锁问题：在解释器关
  闭期间如果通过 "os.fork()" 创建的子进程仍然持有打开的资源跟踪器的管
  道则父进程可能在 "os.waitpid()" 中无限挂起。

* gh-146292: Add colour to "BaseHTTPRequestHandler" logs, as used by
  the "http.server" CLI. Patch by Hugo van Kemenade.

* gh-145917: Add MIME types for TTC and Haptics formats to
  "mimetypes". (Contributed by Charlie Lin in gh-145918.)

* gh-145846: Fix memory leak in "_lsprof" when "clear()" is called
  during active profiling with nested calls. "clearEntries()" now
  walks the entire "currentProfilerContext" linked list instead of
  only freeing the top context.

* gh-145831: 通过去除完整的 *eol* 字符串而非单个字符修复当
  "eol='\r\n'" 时 "email.quoprimime.decode()" 留下单个 "\r" 的问题。

* gh-145378: Use "PyREPL" as the default input console for "pdb"

* gh-145244: Fixed a use-after-free in "json" encoder when a "default"
  callback mutates the dictionary being serialized.

* gh-117716: Fix "wave" writing of odd-sized "data" chunks by
  appending the required RIFF pad byte and correcting the RIFF chunk
  size field accordingly.

* gh-145200: "hashlib": fix a memory leak when allocating or
  initializing an OpenSSL HMAC context fails.

* gh-145056: Add support for "frozendict" in "dataclasses.asdict()"
  and "dataclasses.astuple()".

* gh-145105: 修复 "csv" 读取器在迭代会从 "__next__" 内部调用同一个读取
  器的的重进入式迭代器时的崩溃问题。

* gh-130750: 恢复 "argparse" 错误消息中选项的引号以提高清晰度并与文档
  保持一致。

* gh-137855: Reduce the import time of "dataclasses" module by ~20%.

* gh-70647: "strptime()" now raises "ValueError" when the format
  string contains "%d" without a year directive. Using "%e" without a
  year now emits a "DeprecationWarning".

* gh-105936: 尝试修改 "dataclasses" 中 *frozen* 和 *slots* 同时为
  "True" 的非字段属性现在将引发 "FrozenInstanceError" 而非 "TypeError"
  。 它们的非 dataclass 子类现在可以自由地修改非字段属性，并且原始非
  slot 类可以被垃圾回收。

* gh-142831: Fix a crash in the "json" module where a use-after-free
  could occur if the object being encoded is modified during
  serialization.

* gh-108411: "typing.IO" and "typing.BinaryIO" method arguments are
  now positional-only.

* gh-130273: Fix traceback color output with Unicode characters.

* gh-142307: "imaplib": deprecate support for "IMAP4.file". This
  attribute was never meant to be part of the public interface and
  altering its value may result in unclosed files or other
  synchronization issues with the underlying socket. Patch by Bénédikt
  Tran.

* gh-141449: Improve tests and documentation for non-function
  callables as *annotate functions*.

* gh-140287: 现在 "asyncio" REPL 在执行 "PYTHONSTARTUP" 脚本时将能处理
  异常。 由 Bartosz Sławecki 编写补丁。

* gh-139489: Add the "xml.is_valid_name()" function, which allows to
  check whether a string can be used as an element or attribute name
  in XML.

* gh-75707: Add optional "mtime" argument to "tarfile.open()", for
  setting the "mtime" header field in ".tar.gz" archives.

* gh-125862: The "contextlib.contextmanager()" and
  "contextlib.asynccontextmanager()" decorators now work correctly
  with generators, coroutine functions, and async generators when the
  wrapped callables are used as decorators.

* gh-135528: "http.cookiejar": add "tv", "or", "nom", "sch", and "web"
  to the default list of supported country code second-level domains.

* gh-135056: Add a "-H" or "--header" CLI option to **python -m
  http.server**. Contributed by Anton I. Sipos.

* gh-134551: Add t-strings support to pprint functions

* gh-133956: Fix bug where "@dataclass" wouldn't detect "ClassVar"
  fields if "ClassVar" was re-exported from a module other than
  "typing".

* gh-132631: 修复在使用 "JSON CLI" 解析 JSON 多行文件时的 "I/O
  operation on closed file" 问题。

* gh-108951: "asyncio": Add "TaskGroup.cancel" which cancels
  unfinished tasks and exits the group without raising
  "asyncio.CancelledError".

* gh-123853: Update the table of Windows language code identifiers
  (LCIDs) used by "locale.getdefaultlocale()" on Windows to protocol
  version 16.0 (2024-04-23).

* gh-122476: The "email" module no longer incorrectly uses **RFC
  2047** encoding for a mailbox with non-ASCII characters in its
  local-part. Under a policy with "utf8" set "False", attempting to
  serialize such a message will now raise an "HeaderWriteError". There
  is no valid 7-bit encoding for an internationalized local-part. Use
  "email.policy.SMTPUTF8" (or another policy with "utf8=True") to
  correctly pass through the local-part as Unicode characters.

* gh-83938: The "email" module no longer incorrectly uses **RFC 2047**
  encoding for a mailbox with non-ASCII characters in its domain.
  Under a policy with "utf8" set "False", attempting to serialize such
  a message will now raise an "HeaderWriteError". Either apply an
  appropriate IDNA encoding to convert the domain to ASCII before
  serialization, or use "email.policy.SMTPUTF8" (or another policy
  with "utf8=True") to correctly pass through the internationalized
  domain name as Unicode characters.

* gh-81074: The "email" module no longer treats email addresses with
  non-ASCII characters as defects when parsing a Unicode string or in
  the "addr_spec" parameter to "email.headerregistry.Address". **RFC
  5322** permits such addresses, and they were already supported when
  parsing bytes and in the Address "username" parameter.

  The (undocumented) "email.errors.NonASCIILocalPartDefect" is no
  longer used and should be considered deprecated.

* gh-70039: 修复当 "smtplib.SMTP.connect()" 被显式调用而不是隐式调用时
  "smtplib.SMTP.starttls()" 可能失败的程序缺陷。

* gh-113471: Allow "http.server" to set a default content-type when
  serving files with an unknown or missing extension.

* gh-83281: "email": 改进对地址列表末尾部垃圾条目的处理以避免在某些边
  界情况下抛出 AttributeError。

* gh-96894: Do not turn echo off for subsequent commands in batch
  activators ("activate.bat" and "deactivate.bat") of "venv".


文档
----

* gh-148663: 在文档中写明自 Python 3.12 起
  "calendar.IllegalMonthError" 同时为 "ValueError" 和 "IndexError" 的
  子类。

* gh-146646: 将 "glob.glob()", "glob.iglob()", "pathlib.Path.glob()"
  和 "pathlib.Path.rglob()" 会静默地抑制因扫描文件系统而引发的
  "OSError" 异常写入文档。


测试
----

* gh-149425: 增加 "test.test_zipfile.test_core.OtherTests.test_write_
  without_source_date_epoch" 中的时间差

* gh-148600: Add OpenSSL 4.0.0 support to test configurations.


构建
----

* gh-149353: Avoid unnecessary JIT-related rebuilds during "make
  install" after "--enable-optimizations" builds.

* gh-149351: 避免当在构建期间指定 DESTDIR 时可能破坏 macOS 框架安装名
  称的问题。

* gh-149252: Update to WASI SDK 33.

* gh-148690: Windows free-threaded builds now output to a different
  default path with default filenames, for example,
  "PCbuild/amd64t/python.exe" rather than
  "PCbuild/amd64/python3.15t.exe". The "PC/layout" script has been
  updated to ensure compatibility of generated layouts.

* gh-146475: 阻止使用 Apple Clang 来构建 JIT 因为它没有附带必要的 LLVM
  工具。

* gh-148644: Errors during the PGO training job on Windows are no
  longer ignored, and a non-zero return code will cause the build to
  fail.

* gh-148535: 在 i686 上不再使用 "gcc -fprofile-update=atomic" 旗标。
  该旗标被添加用于修复 PGO 构建 (gh-145801) 上配置数据 (.gcda 文件) 损
  坏导致的随机 GCC 内部错误。 它的问题是在 i686 上使 PGO 构建大幅变慢
  （减速至多 47x）。 由于在 i686 上还未出现 GCC 内部错误，请不要再在
  i686 上使用 "-fprofile-update=atomic"。 由 Victor Stinner 编写补丁。

* gh-148483: Use "Py_GCC_ATTRIBUTE(unused)" for stop_tracing label.

* gh-148474: Fixed compilation of "Python/pystrhex.c" with older clang
  versions.

* gh-146445: The Android build tools have been moved to the Platforms
  folder.

* gh-146264: 当 "MODULE_BUILDTYPE=static" 时通过链接 HACL 依赖作为静态
  库修复在非 WASI 目标上的静态模块构建问题，防止在链接时出现重复
  "_Py_LibHacl_*" 符号错误。

* gh-138451: Allow for custom LLVM path using "LLVM_TOOLS_INSTALL_DIR"
  during JIT build.

* gh-133312: Add a new "./configure" option "--enable-static-
  libpython-for-interpreter" which, when used with "--enable-shared",
  continues to build the shared library but does not use it for the
  interpreter. Instead, libpython is statically linked into the
  interpreter, as if "--enable-shared" had not been used. This allows
  you to do a single build and get a Python interpreter binary that
  does not use a shared library but also get a shared library for use
  by other programs.


Windows
-------

* gh-149254: Updated bundled version of OpenSSL to 3.5.6.

* gh-148690: Non-freethreaded builds on Windows now support extensions
  linked to "python3t.dll", and will include a copy of that library in
  normal installs that references the non-freethreaded runtime.

* gh-146458: 修复在 Windows 上当改变控制台窗口大小时不正确的 REPL 高度
  和宽度追踪。


macOS
-----

* gh-142295: 针对 Python macOS 框架构建版，将 Info.plist 文件更新为更
  符合当前 Apple 指导方针。 原始补丁由 Martinus Verburg 贡献。

* gh-149254: Update macOS installer to use OpenSSL 3.5.6.


IDLE
----

* gh-94523: Detect file if modified at local disk and prompt to ask
  refresh. Patch by Shixian Li.

* gh-139551: Support rendering "BaseExceptionGroup" in IDLE.

* gh-89520: Make IDLE extension configuration look at user config
  files, allowing user-installed extensions to have settings and key
  bindings defined in ~/.idlerc.


C API
-----

* gh-149225: "PyCriticalSection" and related functions are added to
  the Stable ABI.

* gh-149216: "PyType_WatchCallback" callbacks registered via
  "PyType_AddWatcher()" are now also invoked when a watched heap type
  is deallocated. Previously, type watchers were only notified of
  modifications, which could cause stale references when a type was
  freed and its address was reused.

* gh-149101: Implement **PEP 788**.

* gh-149044: Implement **PEP 820**: Unified slot system for the C API.

* gh-148267: Using "Py_LIMITED_API" on a non-Windows free-threaded
  build no longer needs an extra "Py_GIL_DISABLED".

* gh-145559: Rename "_Py_DumpTraceback" and "_Py_DumpTracebackThreads"
  to "PyUnstable_DumpTraceback()" and
  "PyUnstable_DumpTracebackThreads()".

* gh-146636: Implement **PEP 803** -- "abi3t": Stable ABI for Free-
  Threaded Builds.

* gh-146302: "Py_IsInitialized()" no longer returns true until
  initialization has fully completed, including import of the "site"
  module.  The underlying runtime flags now use atomic operations.

* gh-146063: Add "PyObject_CallFinalizerFromDealloc()" function to the
  limited C API. Patch by Victor Stinner.

* gh-145921: Add functions that are guaranteed to be safe for use in
  "tp_traverse" handlers: "PyObject_GetTypeData_DuringGC()",
  "PyObject_GetItemData_DuringGC()",
  "PyType_GetModuleState_DuringGC()", "PyModule_GetState_DuringGC()",
  "PyModule_GetToken_DuringGC()", "PyType_GetBaseByToken_DuringGC()",
  "PyType_GetModule_DuringGC()", "PyType_GetModuleByToken_DuringGC()".


Python 3.15.0 alpha 8
=====================

*发布日期: 2026-04-07*


安全性
------

* gh-145986: "xml.parsers.expat": 修复在使用 "ElementDeclHandler()" 转
  换深度嵌套的XML 内容模型时由无限 C 递归导致的崩溃问题。 这解决了
  **CVE 2026-4224**。

* gh-145599: 拒绝在 "http.cookies.Morsel" "update()" 和 "js_output()"
  中出现控制字符。 这解决了 **CVE 2026-3644**。

* gh-143930: 拒绝传给 "webbrowser.open()" 的 URL 中带有开头横杠符。


核心与内置函数
--------------

* gh-148157: 修复当解析针对函数形参的无效类型注释时可能发生的崩溃问题
  。 由 OSS Fuzz 在 #492782951 中贡献。

* gh-100239: Propagate result type and uniqueness information through
  "_BINARY_OP_EXTEND" in the tier 2 optimizer, enabling elimination of
  downstream type guards and selection of inplace float operations.

* gh-148144: 在拷贝解释器帧时初始化 "_PyInterpreterFrame.visited" 以使
  增量式 GC 不会读取来自生成器和帧对象拷贝的未初始化字节数据。

* gh-148072: Cache "pickle.dumps" and "pickle.loads" per interpreter
  in the XIData framework, avoiding repeated module lookups on every
  cross-interpreter data transfer.  This speeds up
  "InterpreterPoolExecutor" for mutable types ("list", "dict") by 1.7x
  --3.3x.

* gh-148110: Fix "sys.set_lazy_imports_filter()" so relative lazy
  imports pass the resolved imported module name to the filter
  callback. Patch by Pablo Galindo.

* gh-148083: Constant-fold "_CONTAINS_OP_SET" for "frozenset". Patch
  by Donghee Na.

* gh-144319: Fix a bug that could cause applications with specific
  allocation patterns to leak memory via Huge Pages if compiled with
  Huge Page support. Patch by Pablo Galindo

* gh-147985: Make "PySet_Contains()" attempt a lock-free lookup,
  similar to "set.__contains__()".  This avoids acquiring the set
  object mutex in the normal case.

* gh-147856: Allow the *count* argument of "bytes.replace()" to be a
  keyword.

* gh-146615: 修复针对 METH_METHOD 描述器的 "__get__()" 中当将无效的（
  空类型）对象作为第二个参数传入时的崩溃问题。 由 Steven Sun 编写补丁
  。

* gh-146306: Optimize compact integer arithmetic in the JIT by
  mutating uniquely-referenced operands in place, avoiding allocation
  of a new int object. Speeds up the pyperformance "spectral_norm"
  benchmark by ~10%.

* gh-146587: Fix type slot assignment incase of multiple slots for
  same name in type object implementation. Patch by Kumar Aditya.

* gh-126910: Set frame pointers in "aarch64-unknown-linux-gnu" JIT
  code, allowing most native profilers and debuggers to unwind through
  them. Patch by Diego Russo

* gh-146388: Adds a null check to handle when the JIT optimizer runs
  out of space when dealing with contradictions in "make_bottom".

* gh-146369: Ensure "-X lazy_imports=none" and
  "PYTHON_LAZY_IMPORTS=none" override "__lazy_modules__". Patch by
  Hugo van Kemenade.

* gh-146308: Fixed multiple error handling issues in the
  "_remote_debugging" module including a double-free in code object
  caching, memory leaks on allocation failure, missing exception
  checks in binary format varint decoding, reference leaks on error
  paths in frame chain processing, and inconsistent thread status
  error reporting across platforms. Patch by Pablo Galindo.

* gh-146306: Optimize float arithmetic in the JIT by mutating
  uniquely-referenced operands in place, avoiding allocation of a new
  float object. Speeds up the pyperformance "nbody" benchmark by ~19%.

* gh-146128: 修复在 AArch64 JIT 代码中可能导致常量值部分损坏的程序缺陷
  。 此问题是理论性的，并未在未修改的 Python 解释器中被实际观察到。

* gh-146250: 修复 "SyntaxError" 在重初始化时的内存泄漏问题。

* gh-146245: 修复 "socket" 中审计钩子在 "socket.getaddrinfo()" 和
  "socket.sendto()" 中引发异常时的引用泄漏问题。

* gh-146151: "memoryview" now supports the float complex and double
  complex C types: formatting characters "'F'" and "'D'" respectively.
  Patch by Sergey B Kirpichev.

* gh-146196: 通过添加零长度检测修复 "PyUnicodeWriter_WriteASCII()" 中
  潜在的未定义行为。 由 Shamil Abdulaev 编写补丁。

* gh-146227: 修复 C11 atomics 后端 ("pyatomic_std.h") 的
  "_Py_atomic_load_uint16" 中的错误类型，它使用了 32 位的 atomic 载荷
  而不是 16 位的。 由 Mohammed Zuhaib 发现。

* gh-146205: Fixed a bug where "select.epoll.close()",
  "select.kqueue.close()", and "select.devpoll.close()" silently
  ignored errors.

* gh-146199: Comparison of code objects now handles errors correctly.

* gh-145667: Remove the "GET_ITER_YIELD_FROM" instruction, modifying
  "SEND" to pair with "GET_ITER" when compiling "yield from"
  expressions.

* gh-146192: Add Base32 support to "binascii" and improve the
  performance of the Base32 converters in "base64". Patch by James
  Seo.

* gh-135871: Improve multithreaded scaling of PyMutex in low-
  contention scenarios by reloading the lock's internal state, without
  slowing down high-contention scenarios.

* gh-146096: Fixed segmentation fault when called repr for
  BaseExceptionGroup with empty or 1-size tuple args.

* gh-146056: 修复包含 "NULL" 的列表和元组的 "repr()"。

* gh-145059: Fixed "sys.lazy_modules" to include lazy modules without
  submodules. Patch by Bartosz Sławecki.

* gh-146041: 当字符串已被内部化和永生化时通过避免使用解释器级锁修复自
  由线程版在 "sys.intern()" 和 "PyObject_SetAttr()" 中的缩放瓶颈。

* gh-145990: "python --help-env" 各部分现在将按环境变量名称排序。

* gh-145990: "python --help-xoptions" 现在将按 "-X" 选项名称排序。

* gh-145876: "AttributeError"s and "KeyError"s raised in "keys()" or
  "__getitem__()" during dictionary unpacking ("{**mymapping}" or
  "func(**mymapping)") are no longer masked by "TypeError".

* gh-127958: Support tracing from function entrypoints in the JIT.
  Patch by Ken Jin.

* gh-145376: 修复 "structseq.__replace__()" 中的 GC 追踪问题。

* gh-145792: 修复当在编译时未启用 VLA 支持的 CPython 构建版上唤起错误
  处理器时出现越界访问的问题。

* gh-142183: 避免在特定栈深度上重复调用会导致速度大幅变慢的病态现象。

* gh-145779: 通过避免调用描述器的 "__get__" 来提升 "classmethod()" 和
  "staticmethod()" 调用的适应性。

* gh-145783: 修复当有特定错误未被正确传播时解析器的意外崩溃问题。 由
  OSS Fuzz 在 #491369109 中发现。.

* gh-145685: 在 *free-threaded build* 中通过避免对内部类型锁的争夺改善
  类型属性查找的灵活性。

* gh-145713: 通过使用关键节并调用 resize 函数持有锁的版本使得
  "bytearray.resize()" 在自由线程构建中是线程安全的。

* gh-145036: 在自由线程构建版中，修复在 "list" 上调用 "__sizeof__()"
  时的竞争条件问题。

* gh-134584: Eliminate redundant refcounting for "MATCH_CLASS" in the
  JIT.

* gh-69605: Add "math.integer" to *REPL* auto-completion of imports.

* gh-131798: Optimize "_ITER_CHECK_RANGE" and "_ITER_CHECK_LIST" in
  the JIT

* gh-143414: Add tracking to the JIT optimizer to determine whether a
  reference is uniquely owned or shared

* gh-143636: 修复在非命名空间实例上调用
  "SimpleNamespace.__replace__()" 时的崩溃问题。 由 Bénédikt Tran 编写
  补丁。

* gh-126910: Set frame pointers in "x86_64-unknown-linux-gnu" JIT
  code, allowing most native profilers and debuggers to unwind through
  them.

* gh-140594: 修正当从标准输入读取单个 NUL 字符时的读取越界问题。 由
  Shamil Abdulaev 编写补丁。

* gh-140870: Add support for module attributes in the *REPL* auto-
  completion of imports.


库
--

* gh-144503: Fix a regression introduced in 3.14.3 and 3.13.12 where
  the "multiprocessing" "forkserver" start method would fail with
  "BrokenPipeError" when the parent process had a very large
  "sys.argv".  The argv is now passed to the forkserver as separate
  command-line arguments rather than being embedded in the "-c"
  command string, avoiding the operating system's per-argument length
  limit.

* gh-148153: "base64.b32encode()" now always raises "ValueError"
  instead of "AssertionError" for the value of *map01* with invalid
  length.

* gh-73613: Add the *padded* parameter in functions related to Base32
  and Base64 codecs in the "binascii" and "base64" modules. In the
  encoding functions it controls  whether the pad character can be
  added in the output, in the decoding functions it controls whether
  padding is required in input. Padding of input no longer required in
  "base64.urlsafe_b64decode()" by default.

* gh-146613: "itertools": 修复 "itertools.groupby()" 中当 grouper 迭代
  器被并发修改时的崩溃问题。

* gh-147944: Accepted range for the *bytes_per_sep* argument of
  "bytes.hex()", "bytearray.hex()", "memoryview.hex()", and
  "binascii.b2a_hex()" is now increased, so passing "sys.maxsize" and
  "-sys.maxsize" is now valid.

* gh-146080: "ssl": 修复当一个 SNI 回调试图使用已被作为垃圾回收的 SSL
  对象时的崩溃问题。 由 Bénédikt Tran 编写补丁。

* gh-146556: 修复在具有循环的 "__wrapped__" 链 (例如 "f.__wrapped__ =
  f") 的可调用对象上调用 "annotationlib.get_annotations()" 并传入
  "eval_str=True" 时无限挂起的问题。 循环检测使用基于标识号的已访问集
  现在将停止遍历并回退至目前已找到的全局变量，即沿用
  "inspect.unwrap()" 的方式。

* gh-146090: "sqlite3": 修复当 "sqlite3.Connection.create_collation()"
  因 SQLITE_BUSY 而执行失败时的崩溃问题。 由 Bénédikt Tran 编写补丁。

* gh-146090: "sqlite3": 当分配上下文回调失败时将正确地引发
  "MemoryError" 而不是 "SystemError"。 由 Bénédikt Tran 编写补丁。

* gh-146507: Make "asyncio.SelectorEventLoop()" stream transport's
  "get_write_buffer_size()" O(1) by maintaining a running byte counter
  instead of iterating the buffer on every call.

* gh-145056: Fix merging of "collections.OrderedDict" and
  "frozendict".

* gh-145056: Add support for merging "collections.UserDict" and
  "frozendict".

* gh-145633: 修正 "struct.pack('f', float)": 使用 "PyFloat_Pack4()" 来
  引发 "OverflowError"。 由 Sergey B Kirpichev 和 Victor Stinner 编写
  补丁。

* gh-146440: "json": Add the *array_hook* parameter to "load()" and
  "loads()" functions: allow a callback for JSON literal array types
  to customize Python lists in the resulting decoded object. Passing
  combined "frozendict" to *object_pairs_hook* param and "tuple" to
  "array_hook" will yield a deeply nested immutable Python structure
  representing the JSON data.

* gh-146431: Add the *wrapcol* parameter to "base64" functions
  "b16encode()", "b32encode()", "b32hexencode()", "b85encode()" and
  "z85encode()", and "binascii" functions "b2a_base32()" and
  "b2a_base85()". Add the *ignorechars* parameter to "base64"
  functions "b16decode()", "b32decode()", "b32hexdecode()",
  "b85decode()" and "z85decode()", and "binascii" functions
  "a2b_hex()", "unhexlify()", "a2b_base32()" and "a2b_base85()".

* gh-146310: "ensurepip" 模块将不会在当前目录下查找 "pip-*.whl" wheel
  包。

* gh-141510: Support "frozendict" in "plistlib", for serialization
  only. Patch by Hugo van Kemenade.

* gh-146238: Support half-floats (type code "'e'" of the "struct"
  module) in the "array" module.  Patch by Sergey B Kirpichev.

* gh-140947: Fix incorrect contextvars handling in server tasks
  created by "asyncio". Patch by Kumar Aditya.

* gh-146151: Support the float complex and double complex C types in
  the "array" module: formatting characters "'F'" and "'D'"
  respectively.  Patch by Sergey B Kirpichev.

* gh-143387: In importlib.metadata, when a distribution file is
  corrupt and there is no metadata file, calls to
  "Distribution.metadata()" (including implicit calls from other
  properties like ".name" and ".requires") will now raise a
  "MetadataNotFound" Exception. This allows callers to distinguish
  between missing metadata and a degenerate (empty) metadata.
  Previously, if the file was missing, an empty "PackageMetadata"
  would be returned and would be indistinguishable from the presence
  of an empty file.

* gh-146228: Cached FastPath objects in importlib.metadata are now
  cleared on fork, avoiding broken references to zip files during
  fork.

* gh-146171: Nested "AttributeError" suggestions now include property-
  backed attributes on nested objects without executing the property
  getter.

* gh-145410: On Windows, "sysconfig.get_platform()" now gets the
  platform from the "_sysconfig" module instead of parsing
  "sys.version" string. Patch by Victor Stinner.

* gh-146091: Fix a bug in "termios.tcsetwinsize()" where passing a
  sequence that raises an exception in "__getitem__" would cause a
  "SystemError" instead of propagating the original exception.

* gh-146083: 将捆绑的 libexpat 更新至 2.7.5。

* gh-146076: "zoneinfo": 修复当从 "zoneinfo.ZoneInfo" 子类删除
  "_weak_cache" 时发生崩溃的问题。

* gh-123471: Make concurrent iteration over "itertools.zip_longest"
  safe under free-threading.

* gh-146075: Errors when calling "functools.partial()" with a
  malformed keyword will no longer crash the interpreter.

* gh-146054: 限制 "encodings.search_function()" 缓冲区的大小。 由 OSS
  Fuzz 在 #493449985 中发现。

* gh-146004: 现在所有来自 Python 命令行的 "-X" 选项都将传播到由
  "multiprocessing" 通过 spawn 启动的子进程，而不只是一个硬编码的子集
  。 这使得默认 "spawn" 和 "forkserver" 启动方法与旧式 "fork" 启动方法
  之间的行为保持一致。 之前不会被传播的选项是:
  "context_aware_warnings", "cpu_count", "disable-remote-debug",
  "int_max_str_digits", "lazy_imports", "no_debug_ranges",
  "pathconfig_warnings", "perf", "perf_jit", "presite",
  "pycache_prefix", "thread_inherit_context" 和
  "warn_default_encoding"。

* gh-145980: Added the *alphabet* parameter in "b2a_base64()",
  "a2b_base64()", "b2a_base85()" and "a2b_base85()" and a number of
  "*_ALPHABET" constants in the "binascii" module. Removed "b2a_z85()"
  and "a2b_z85()".

* gh-145968: Fix translation in "base64.b64decode()" when altchars
  overlaps with the standard ones.

* gh-145966: Non-"AttributeError" exceptions raised during dialect
  attribute lookup in "csv" are no longer silently suppressed.

* gh-145883: "zoneinfo": Fix heap buffer overflow reads from malformed
  TZif data. Found by OSS Fuzz, issues #492245058 and #492230068.

* gh-145850: Changed some implementation details in "struct.Struct":
  calling it with non-ASCII string format will now raise a
  "ValueError" instead of "UnicodeEncodeError", calling it with non-
  ASCII bytes format will now raise a "ValueError" instead of
  "struct.error", getting the "format" attribute of uninitialized
  object will now raise an "AttributeError" instead of "RuntimeError".

* gh-123720: asyncio: Fix "asyncio.Server.serve_forever()" shutdown
  regression. Since 3.12, cancelling "serve_forever()" could hang
  waiting for a handler blocked on a read from a client that never
  closed (effectively requiring two interrupts to stop); the shutdown
  sequence now ensures client streams are closed so "serve_forever()"
  exits promptly and handlers observe EOF.

* gh-138122: The "profiling.sampling" module now supports differential
  flamegraph visualization via "--diff-flamegraph" to compare two
  profiling runs. Functions are colored red (regressions), blue
  (improvements), gray (neutral), or purple (new). Elided stacks show
  code paths that disappeared between runs.

* gh-145754: 在模拟使用 "FORWARDREF" 标注格式的 autospec 期间请求签名
  。 这将防止在标注使用未在运行时定义的名称时发生运行时错误。

* gh-145750: 当在 "struct" 模块中解析格式字符串时避免来自有符号整数溢
  出的未定义行为。 由 OSS Fuzz 在 #488466741 中发现。

* gh-145719: Add "application/efi" MIME type to "mimetypes".

* gh-145717: Add a few Microsoft-specific MIME types.

* gh-145703: "asyncio": Make sure that "loop.call_at" and
  "loop.call_later" trigger scheduled events on time when the clock
  resolution becomes too small.

* gh-145697: Add "application/sql" and "application/vnd.sqlite3" into
  "mimetypes".

* gh-145492: 修复 "collections.defaultdict" "__repr__" 中当一个
  "defaultdict" 包含其自身时的的无限回归问题。 基于 KowalskiThomas 在
  gh-145492 中的分析。

* gh-145650: Add "__repr__()" support to "logging.Formatter" and
  "logging.Filter", showing the format string and filter name
  respectively.

* gh-145587: Resolved a performance regression in
  "multiprocessing.connection.wait" on Windows that caused infinite
  busy loops when called with no objects. The function now properly
  yields control to the OS to conserve CPU resources. Patch By Shrey
  Naithani

* gh-145616: 在 64 位 ARM 内核上的 32 位 ARM Android 中正确检测
  Android sysconfig ABI。

* gh-145546: Fix "unittest.util.sorted_list_difference()" to
  deduplicate remaining elements when one input list is exhausted
  before the other.

* gh-145446:现在当在 "functools.partial()" 中使用关键字参数时自由线程
  构建上的 "functools" 将更为安全

* gh-145264: Base64 decoder (see "binascii.a2b_base64()",
  "base64.b64decode()", etc) no longer ignores excess data after the
  first padded quad in non-strict (default) mode.  Instead, in
  conformance with **RFC 4648**, section 3.3, it now ignores the pad
  character, "=", if it is present before the end of the encoded data.

* gh-145035: Allows omitting the internal library "_pyrepl" with
  limited loss of functionality. This allows complete removal of the
  modern REPL, which is an unsupported configuration, but still
  desirable for some distributions.

* gh-144270: Made the *tag* parameter of
  "xml.etree.ElementTree.Element" and the *parent* and *tag*
  parameters of "xml.etree.ElementTree.SubElement()" positional-only,
  matching the behavior of the C accelerator.

* gh-144984: Fix crash in
  "xml.parsers.expat.xmlparser.ExternalEntityParserCreate()" when an
  allocation fails. The error paths could dereference NULL "handlers"
  and double-decrement the parent parser's reference count.

* gh-144975: "wave.Wave_write.setframerate()" now validates the frame
  rate after rounding to an integer, preventing values like "0.5" from
  being accepted and causing confusing errors later. Patch by Michiel
  Beijen.

* gh-140715: Add "%n" and "%t" support to "strptime()".

* gh-144259: 修正F REPL 中多行长文本粘贴内容显示不一致的问题。

* gh-140814: "multiprocessing.freeze_support()" no longer sets the
  default start method as a side effect, which previously caused a
  subsequent "multiprocessing.set_start_method()" call to raise
  "RuntimeError".

* gh-123471: Make concurrent iteration over "itertools.accumulate"
  safe under free-threading.

* gh-143715: Calling the "Struct.__new__()" without required argument
  now is deprecated. Calling "__init__()" method on initialized
  "Struct" objects is deprecated.

* gh-142763: 修复在 "zoneinfo.ZoneInfo" 创建和
  "zoneinfo.ZoneInfo.clear_cache()" 之间可能引发 "KeyError" 的竞争条件
  问题。

* gh-141707: 在解析 GNU 长名称或链接标头时不会将 "tarfile.TarInfo" 类
  型从 "AREGTYPE" 改为 "DIRTYPE"。

* gh-138577: "getpass.getpass()" with non-empty "echo_char" now
  handles keyboard shortcuts including Ctrl+A/E (cursor movement),
  Ctrl+K/U (kill line), Ctrl+W (erase word), and Ctrl+V (literal next)
  by reading the terminal's control character settings and processing
  them appropriately in non-canonical mode. Patch by Sanyam Khurana.

* gh-140049: "traceback.format_exception_only()" now colorizes
  exception notes.

* gh-139933: 改进针对带有会返回由不可排序值组成的列表的自定义
  "__dir__()" 方法的类的 "AttributeError" 提示。 由 Bénédikt Tran 编写
  补丁。

* gh-139633: The "netrc" security check is now run once per parse
  rather than once per entry.

* gh-130472: Add fancycompleter and enable it by default when using
  pyrepl. This gives colored tab completion.

* gh-112632: Add an *expand* keyword argument for "pprint.pprint()",
  "pprint.pformat()", "pprint.pp()" by passing on all *kwargs* and
  "pprint.PrettyPrinter". Contributed by Stefan Todoran and Semyon
  Moroz.

* gh-66419: Optional argument with nargs equals to
  "argparse.REMAINDER" now consumes all remaining arguments including
  "'--'".

* gh-60729: Add support for floating point audio wave files in "wave".

* bpo-36461: Make the target time of "timeit.Timer.autorange()"
  configurable and add "--target-time" option to the command-line
  interface of "timeit".


文档
----

* gh-126676: 扩展 "argparse" 文档的 "type=bool" 部分以展示意外行为并提
  示常用替代方式。

* gh-145649: 通过使用正确的 roff 标记修正 *python(1)* 手册页面中 "-X"
  选项说明的文字换行和格式问题。


测试
----

* gh-144418: Android testbed 的模拟器 RAM 从 2 GB 增加至 4 GB。

* gh-146202: 修复 regrtest 中的竞争条件问题：确保在工作进程中创建临时
  目录。 在之前版本中，temp_cwd() 在 Windows 上当 "build" 目录未被创建
  时执行将失败。 由 Victor Stinner 编写补丁。


构建
----

* gh-146541: 现在 Android testbed 可以针对 32 位 ARM 和 x86 目标进行构
  建。

* gh-146498: iOS XCframework 构建脚本现在会确保 libpython 不被包括在安
  装的 app 内容中，并在标识需要处理的标准库二进制内容时更为稳定可靠。

* gh-146450: 修改了 Android 构建脚本以提升与其他平台构建脚本的一致性。

* gh-146446: 现在 Apple/iOS XCframework 构建脚本的 clean 目标在针对单
  一架构时将更具选择性。

* gh-146444: The Apple/iOS build script has been moved to the
  Platforms directory.

* gh-146210: Fix building the jit stencils on Windows when the
  interpreter is built with a different clang version. Patch by Chris
  Eibl.

* gh-145844: Update to WASI SDK 32.

* gh-145801: When Python build is optimized with GCC using PGO, use
  "-fprofile-update=atomic" option to use atomic operations when
  updating profile information. This option reduces the risk of gcov
  Data Files (.gcda) corruption which can cause random GCC crashes.
  Patch by Victor Stinner.

* gh-138850: Add "--disable-epoll" to "configure"

* gh-145633: Remove support for ancient ARM platforms (ARMv4L and
  ARMv5L OABI boards), using mixed-endian representation for doubles.
  Patch by Sergey B Kirpichev.

* gh-85277: Fix building without "stropts.h" or empty "stropts.h"


Windows
-------

* gh-140131: 修正在 Windows 上当模块补全建议行达到控制台窗口宽度时的
  REPL 光标位置问题。


macOS
-----

* gh-137586: 在 "webbrowser" 和 "turtledemo" 使用绝对路径唤起
  **osascript**。


工具/示例
---------

* gh-135953: Properly identify the main thread in the Gecko profiler
  collector by using a status flag from the interpreter state instead
  of relying on "threading.main_thread()" in the collector process.

* gh-145976: Remove "Misc/indent.pro", a configuration file for GNU
  *indent(1)*.

* gh-145976: Remove "Misc/vgrindefs" and "Misc/Porting".


C API
-----

* gh-146636: The "Py_mod_abi" slot is now mandatory for modules
  created from a slots array (using "PyModule_FromSlotsAndSpec()" or
  the "PyModExport_*" export hook).

* gh-146175: The following macros are *soft deprecated*: "Py_ALIGNED",
  "PY_FORMAT_SIZE_T", "Py_LL", "Py_ULL", "PY_LONG_LONG",
  "PY_LLONG_MIN", "PY_LLONG_MAX", "PY_ULLONG_MAX", "PY_INT32_T",
  "PY_UINT32_T", "PY_INT64_T", "PY_UINT64_T", "PY_SIZE_MAX",
  "Py_UNICODE_SIZE", "Py_VA_COPY".

  The macro "Py_UNICODE_WIDE", which was scheduled for removal, is
  *soft deprecated* instead.

* gh-146143: "PyUnicodeWriter_WriteUCS4()" now accepts a pointer to a
  constant buffer of "Py_UCS4".

* gh-146056: "PyUnicodeWriter_WriteRepr()" 现在支持 "NULL" 参数。

* gh-145010: 针对 "object.h" 中的内联汇编使用使用 GCC 方言替代方式以使
  Python 头文件在设置 "-masm=intel" 时正确编译。


Python 3.15.0 alpha 7
=====================

*Release date: 2026-03-10*


Windows
-------

* gh-145731: Fix negative timestamp during DST on Windows. Patch by
  Hugo van Kemenade.

* gh-145307: 延迟 "psapi.dll" 模块的加载直到它被
  "ctypes.util.dllist()" 使用。

* gh-144551: Updated bundled version of OpenSSL to 3.5.5.


测试
----

* gh-144741: Fix "test_frame_pointer_unwind" when Python is built with
  "--enable-shared". Classify also libpython frames as ""python"".
  Patch by Victor Stinner.

* gh-144739: 如果编译 Python 时使用的系统 expat 版本早于 2.7.2 但测试
  运行时使用较新的 expat，则仍然会跳过
  "test.test_pyexpat.MemoryProtectionTest"。


安全性
------

* gh-145506: 通过确保 "SourcelessFileLoader" 在打开 ".pyc" 文件时使用
  "io.open_code()" 修复 **CVE 2026-2297** 问题。

* gh-144370: 不允许在 "wsgiref.handlers" 的状态中使用控制字符以防止
  HTTP 标头注入。 由 Benedikt Johannes 编写补丁。


库
--

* gh-145623: 修复 "struct" 中当在通过 "Struct.__new__()" 而不调用
  "__init__()" 创建的未初始化 "struct.Struct" 对象上调用 "repr()" 或
  "__sizeof__()" 时的崩溃问题。

* gh-145551: 修复当取消由 "asyncio.create_subprocess_exec()" 或
  "asyncio.create_subprocess_shell()" 创建的进程时引发
  InvalidStateError 的问题。 由 Daan De Meyer 编写补丁。

* gh-141510: "marshal" now supports "frozendict" objects. The marshal
  format version was increased to 6. Patch by Victor Stinner.

* gh-145417: "venv": 防止在拷贝 "Activate.ps1" 脚本时不正确地保留
  SELinux 上下文。 该脚本继承了系统模板目录的 SELinux 安全上下文，而不
  是目标项目目录的。

* gh-145335: "os.listdir(-1)" and "os.scandir(-1)" now fail with
  "OSError(errno.EBADF)" rather than listing the current directory.
  "os.listxattr(-1)" now fails with "OSError(errno.EBADF)" rather than
  listing extended attributes of the current directory. Patch by
  Victor Stinner.

* gh-145376: 修复 "hashlib" 和 "hmac" 模块中在不常见错误场景下的双重释
  放和空指针解引用问题。

* gh-145301: "hmac": 修复当下层的 C 扩展模块初始化失败时的崩溃问题。

* gh-145301: "hashlib": 修复当下层 C 扩展模块的初始化失败时的崩溃问题
  。

* gh-76007: The "version" attribute of the "tarfile" module is
  deprecated and slated for removal in Python 3.20.

* gh-145158: 当解析 "struct" 模块中的格式字符串时避免来自有符号整数溢
  出的未定义行为。

* gh-123853: Removed Windows 95 compatibility for
  "locale.getdefaultlocale()".

* gh-66802: Add "unicodedata.block()" function to return the Unicode
  block of a character.

* gh-145033: Add "typing.TypeForm", implementing **PEP 747**. Patch by
  Jelle Zijlstra.

* gh-141510: "dataclasses.field()": if *metadata* is "None", use an
  empty "frozendict", instead of a "MappingProxyType()" of an empty
  "dict". Patch by Victor Stinner.

* gh-145006: Add "ModuleNotFoundError" hints when a module for a
  different ABI exists.

* gh-141510: "ParameterizedMIMEHeader.params" of
  "email.headerregistry" is now a "frozendict" instead of a
  "types.MappingProxyType". Patch by Victor Stinner.

* gh-134872: Add valid import name suggestions on
  "ModuleNotFoundError".

* gh-88091: 修正韩文字符的 "unicodedata.decomposition()" 问题。

* gh-144986: 修复 "atexit.register()" 中的一个内存泄漏问题。 由 Shamil
  Abdulaev 编写补丁。

* gh-144777: 修复 *free-threaded build* 中
  "io.IncrementalNewlineDecoder" 的数据竞争问题。

* gh-144809: 使 "collections.deque" 的拷贝在 *free-threaded build* 中
  是原子化的。

* gh-141510: The "copy" module now supports the "frozendict" type.
  Patch by Pieter Eendebak based on work by Victor Stinner.

* gh-141510: The "json" module now supports the "frozendict" type.
  Patch by Victor Stinner.

* gh-144835: 为 "glob.glob()" 和 "glob.iglob()" 中的某些形参添加了缺失
  的说明。

* gh-144833: 修复在 "ssl" 中当 "newPySSLSocket()" 的 "SSL_new()" 返回
  NULL 时的一个释放后再使用的问题。 此错误是在对象已被释放后通过一个悬
  空指针来报告的。

* gh-140715: Add "'%D'" support to "strptime()".

* gh-144782: 将 "argparse.ArgumentParser" 修正为 "可 pickle 对象"。

* gh-144763: Fix a race condition in "tracemalloc": it no longer
  detaches the attached thread state to acquire its internal lock.
  Patch by Victor Stinner.

* gh-142224: "unicodedata.bidirectional()" now return the correct
  default bidi class for unassigned code points.

* gh-117865: Reduce the import time of "inspect" module by ~20%.

* gh-144156: 修复当使用 **RFC 2047** 编码的单词时 "email" 库对标头的折
  叠问题。 现在空格符会被正确保留并在相邻的已编码单词间正确添加。 后面
  的属性曾被针对 gh-92081 的修复所破坏，该修复解决了之前大多数未保留空
  格符的问题。

* gh-66305: 修复 Windows 上的 "tempfile" 模块当尝试在不可写的目录下创
  建临时文件或子目录时的挂起问题。

* gh-144615: Methods directly decorated with
  "@functools.singledispatchmethod" now dispatch on the second
  argument when called after being accessed as class attributes. Patch
  by Bartosz Sławecki.

* gh-144321: The functional syntax for creating "typing.NamedTuple"
  classes now supports passing any *iterable* of fields and types.
  Previously, only sequences were supported.

* gh-144475: 现在当生成字符串表示形式时对于 partial 对象的内部属性被替
  换的情况在 "functools.partial()" 上调用 "repr()" 将更为安全。

* gh-144285: Attribute suggestions in "AttributeError" tracebacks are
  now formatted differently to make them easier to understand, for
  example: "Did you mean '.datetime.now' instead of '.now'".
  Contributed by Bartosz Sławecki.

* gh-144316: 修复 "_remote_debugging" 中导致
  "test_external_inspection" 间歇性失败的崩溃问题。 由 Taegyun Kim 编
  写补丁。

* gh-143637: 修复 socket.sendmsg() 中当附属数据在参数解析期间以重进入
  方式被修改时可能发生的崩溃问题。

* gh-140652: 修复 "_interpchannels.list_all()" 中在关闭一个通道后的崩
  溃问题。

* gh-143698: 当调用 "os.posix_spawn()" 或 "os.posix_spawnp()" 时允许
  *scheduler* 和 *setpgroup* 参数被显式地设为 "None"。 由 Bénédikt
  Tran 编写补丁。

* gh-143698: 当 "os.posix_spawn()" 或 "os.posix_spawnp()" 中的
  *scheduler* 不是一个元组时将引发 "TypeError" 而非 "SystemError"。 由
  Bénédikt Tran 编写补丁。

* gh-142516: "ssl": 修复 "ssl.SSLContext" 对象中的引用泄漏问题。 由
  Bénédikt Tran 编写补丁。

* gh-85809: Added *path-like object* support for
  "shutil.make_archive()".

* gh-143304: 修正 "ctypes.CDLL" 以在 POSIX 系统上接受 "handle" 形参。

* gh-142781: "zoneinfo": 修复在内部类级缓存不一致的情况下当初始化
  "ZoneInfo" 对象时的崩溃问题。

* gh-142787: 修复在 "sqlite3" blob 抽取操作中当使用会导致空切片的索引
  进行切片时断言失败的问题。

* gh-142352: 修复 "asyncio.StreamWriter.start_tls()" 以将缓冲数据从
  "StreamReader" 传输至 SSL 层，防止当连接升级为 TLS 中间流（例如在实
  现 PROXY 协议支持）时的数据丢失。

* gh-139899: Introduced "importlib.abc.MetaPathFinder.discover()" and
  "importlib.abc.PathEntryFinder.discover()" to allow module and
  submodule name discovery without assuming the use of traditional
  filesystem based imports.

* gh-137335: 消除 Windows 上在 "multiprocessing" 和 "asyncio" 中任何发
  生命名管道名称冲突的可能性，无论几率有多小。

* gh-135883: Fix "sqlite3"'s interactive shell keeping part of
  previous commands when scrolling history.

* gh-124748: Improve "TypeError" error message when
  "weakref.WeakKeyDictionary.update()" is used with keyword-only
  parameters.

* gh-80667: Add support for Tangut Ideographs names in "unicodedata".

* bpo-42353: The "re" module gains a new "re.prefixmatch()" function
  as an explicit spelling of what has to date always been known as
  "re.match()". "re.Pattern" similary gains a
  "re.Pattern.prefixmatch()" method.

  Why? Explicit is better than implicit. Other widely used languages
  all use the term "match" to mean what Python uses the term "search"
  for. The unadorened "match" name in Python has been a frequent case
  of confusion and coding bugs due to the inconsistency with the rest
  if the software industry.

  We do not plan to deprecate and remove the older "match" name.

* bpo-40243: 修复非十进制数值的 "unicodedata.ucd_3_2_0.numeric()" 问题
  。

* bpo-40212: Re-enable "os.posix_fallocate()" and "os.posix_fadvise()"
  on AIX.

* bpo-3405: Add support for user data of Tk virtual events and detail
  for "Enter", "Leave", "FocusIn", "FocusOut", and "ConfigureRequest"
  events to "tkinter".

* bpo-32234: "mailbox.Mailbox" instances can now be used as a context
  manager. The Mailbox is locked on context entry and unlocked and
  closed at context exit.


文档
----

* gh-145450: 增加缺失的公有 "wave.Wave_write" getter 方法文档。

* gh-110937: Document rest of full public
  "importlib.metadata.Distribution" API. Also add the (already
  documented) "PackagePath" to "__all__".

* gh-136246: 在文档的左边栏中新增“改进此页面”链接，提供了创建 GitHub
  问题、发布讨论帖子或拉取请求的链接。


核心与内置函数
--------------

* gh-145701: 修复当 "__classdict__" 或 "__conditional_annotations__"
  位于类作用域内联推导式中时的 "SystemError" 异常。 由 OSS Fuzz 在
  #491105000 中发现。

* gh-145615: 修正 *free-threaded build* 中 mimalloc 页面可能永久性地无
  法回收直到拥有方线程退出的内存泄漏问题。

* gh-116738: Make "mmap.mmap.set_name()" thread-safe on the *free
  threaded* build.

* gh-145566: In the free threading build, skip the stop-the-world
  pause when reassigning "__class__" on a newly created object.

* gh-143055: Fix crash in AST unparser when unparsing dict
  comprehension unpacking. Found by OSS Fuzz in #489790200.

* gh-145335: 修复 "os.pathconf()" 附带 "-1" 作为 path 参数进行调用时的
  煤库问题。

* gh-145376: 修复多个不常见错误场景中的引用泄漏问题。

* gh-145234: 修复解析器中当编码的 cookie (例如使用 UTF-7) 解码为回车符
  ("\r") 时发生 "SystemError" 的问题。 现在字符串分词器中解码完成后会
  进行标准化处理。

  由 Pablo Galindo 编写补丁。

* gh-145275: Added the "-X pathconfig_warnings" and
  "PYTHON_PATHCONFIG_WARNINGS" options, allowing to disable warnings
  from sys.path 模块搜索路径的初始化.

* gh-145273: A warning is now shown during sys.path 模块搜索路径的初始
  化 if it can't find a valid standard library.

* gh-145241: Specialized the parser error for when "with" items are
  followed by a trailing comma (for example, "with item,:"), raising a
  clearer "SyntaxError" message. Patch by Pablo Galindo and Bartosz
  Sławecki.

* gh-130555: 修复 "dict.clear()" 在字典值是嵌入到某个对象并且析构器导
  致该字典的重进入改变时的释放后使用问题。

* gh-145197: Fix JIT trace crash when recording function from cleared
  generator frame.

* gh-145187: 修复当条件代码块中类型形参绑定包含无效表达式时编译器断言
  失败的问题。

* gh-145142: 修复在自由线程构建中当传给 "str.maketrans()" 的字典参数被
  并发修改时的崩溃问题。

* gh-145118: "str.maketrans()" now accepts "frozendict".

* gh-144015: Speed up "bytes.hex()", "bytearray.hex()",
  "binascii.hexlify()", and "hashlib" ".hexdigest()" operations with
  SIMD on x86-64, ARM64, and ARM32 with NEON when built with gcc
  (version 12 or higher) or clang (version 3 or higher) compilers.
  Around 1.1-3x faster for common 16-64 byte inputs such as hashlib
  hex digests, and up to 8x faster for larger data.

* gh-145118: "type()" now accepts "frozendict" as an argument.

* gh-145064: Fix JIT optimizer assertion failure during
  "CALL_ALLOC_AND_ENTER_INIT" side exit.

* gh-145055: "exec()" and "eval()" now accept "frozendict" for
  *globals*. Patch by Victor Stinner.

* gh-145058: Fix a crash when "__lazy_import__()" is passed a non-
  string argument, by raising an "TypeError" instead.

* gh-144995: Optimize "memoryview" comparison: a "memoryview" is equal
  to itself, there is no need to compare values. Patch by Victor
  Stinner.

* gh-141510: Update specializer to support frozendict. Patch by
  Donghee Na.

* gh-141510: Optimize "frozendict.fromkeys()" to avoid unnecessary
  thread-safety operations in frozendict cases. Patch by Donghee Na.

* gh-100239: Speedup "BINARY_OP_EXTEND" for exact floats and medium-
  size integers by up to 15%. Patch by Chris Eibl.

* gh-144914: Use "mimalloc" for raw memory allocations such as via
  "PyMem_RawMalloc()" for better performance on *free-threaded
  builds*. Patch by Kumar Aditya.

* gh-144872: 修复用 OSS-Fuzz 找到的解析器内堆缓冲区溢出问题。

* gh-144766: 修复当 perf 支持被启用时在分叉子进程中的崩溃问题。

* gh-144759: Fix undefined behavior in the lexer when "start" and
  "multi_line_start" pointers are "NULL" in
  "_PyLexer_remember_fstring_buffers()" and
  "_PyLexer_restore_fstring_buffers()". The "NULL" pointer arithmetic
  ("NULL - valid_pointer") is now guarded with explicit "NULL" checks.

* gh-141510: Add built-in "frozendict" type. Patch by Victor Stinner.

* gh-144681: Fix a JIT assertion failure when a conditional branch
  jumps to the same target as the fallthrough path.

* gh-143300: Add "PyUnstable_SetImmortal()" C-API function to mark
  objects as *immortal*.

* gh-144702: Clarify the error message raised when a class pattern is
  used to match on a non-class object.

* gh-144569: Optimize "BINARY_SLICE" for list, tuple, and unicode by
  avoiding temporary "slice" object creation.

* gh-144438: 将Align the QSBR 线程状态数组对齐到 64 字节缓存行边界以避
  免 *free-threaded build* 中错误的共享。

* gh-142349: Implement **PEP 810**. Patch by Pablo Galindo and Dino
  Viehland.

* gh-141226: Deprecate **PEP 456** support for providing an external
  definition of the string hashing scheme. Removal is scheduled for
  Python 3.19. Patch by Bénédikt Tran.

* gh-138912: Improve "MATCH_CLASS" performance by up to 52% in certain
  cases. Patch by Marc Mueller.

* gh-130327: 修复当对象的 "__dict__" 在运行时被覆盖时错误的清理问题。

* gh-80667: Literals using 使用 "\N{name}" 转义语法的字面值现在可以使
  用大小写不敏感的名称构造 CJK 表意文字和 Hangul 音节。


C API
-----

* gh-142417: Restore private provisional "_Py_InitializeMain()"
  function removed in Python 3.14. Patch by Victor Stinner.

* gh-144748: "PyErr_CheckSignals()" now raises the exception scheduled
  by "PyThreadState_SetAsyncExc()", if any.

* gh-144981: 使 "PyUnstable_Code_SetExtra()",
  "PyUnstable_Code_GetExtra()" 和
  "PyUnstable_Eval_RequestCodeExtraIndex()" 在 *自由线程* 构建版上是线
  程安全的。

* gh-141510: Add the following functions for the new "frozendict"
  type:

  * "PyAnyDict_Check()"

  * "PyAnyDict_CheckExact()"

  * "PyFrozenDict_Check()"

  * "PyFrozenDict_CheckExact()"

  * "PyFrozenDict_New()"

  由Victor Stinner提供补丁。

* gh-121617: "Python.h" now also includes "<string.h>" in the limited
  C API version 3.11 and newer to fix the "Py_CLEAR" macro which uses
  "memcpy()". Patch by Victor Stinner.

* gh-144175: Add "PyArg_ParseArray()" and
  "PyArg_ParseArrayAndKeywords()" functions to parse arguments of
  functions using the "METH_FASTCALL" calling convention. Patch by
  Victor Stinner.


构建
----

* gh-144533: Use wasmtime's "--argv0" to auto-discover sysconfig in
  WASI builds

* gh-145110: Fix targets "Clean" and "CLeanAll" in case of PGO builds
  on Windows. Patch by Chris Eibl.

* gh-144679: When building with Visual Studio 2026 (Version 18), use
  PlatformToolSet v145 by default. Patch by Chris Eibl.

* gh-144675: Update to WASI SDK 30.

* gh-136677: Introduce executable specific linker flags to
  "./configure".


Python 3.15.0 alpha 6
=====================

*Release date: 2026-02-11*


macOS
-----

* gh-144648: Allowed _remote_debugging to build on more OS versions by
  using proc_listpids() rather than proc_listallpids().

* gh-124111: Update macOS installer to use Tcl/Tk 9.0.3.

* gh-144551: Update macOS installer to use OpenSSL 3.5.5.


Windows
-------

* gh-80620: Support negative timestamps in "time.gmtime()",
  "time.localtime()", and various "datetime" functions.


测试
----

* gh-144415: Android testbed 现在会区分由换行符触发的和由手动调用
  "flush" 触发的 stdout/stderr 消息。 这将修正进度提示及类似内容的日志
  记录问题。

* gh-65784: 增加对 regrtests 中参数化资源 "wantobjects" 的支持，这将允
  许运行 Tkinter 测试时使用指定的 "tkinter.wantobjects" 值，例如 "-u
  wantobjects=0"。


安全性
------

* gh-144125: "BytesGenerator" 现在将拒绝序列化（写入）不安全折叠或分隔
  的标头；参见 "verify_generated_headers"。（由 Bas Bloemsaat 和 Petr
  Viktorin 在 gh-121650 中贡献。）

* gh-143935: 修复了使用现代邮件策略扁平化电子邮件消息时注释折叠中的程
  序缺陷。由很长的不可折叠字符序列组成的注释可能会触发强制换行，而该换
  行会省略续行所需的前导空格，导致注释的剩余部分被解释为新的标头字段。
  这使得通过精心构造的输入实现标头注入成为可能。

* gh-143925: 拒绝 "data:" URL 媒体类型中的控制字符。

* gh-143923: Reject control characters in POP3 commands.

* gh-143921: Reject control characters in IMAP commands.

* gh-143919: 拒绝 "http.cookies.Morsel" 字段和值中的控制字符。

* gh-143916: 拒绝 wsgiref.headers.Headers 字段、值和参数之内的 C0 控制
  字符。


库
--

* gh-144538: 将 ensurepip 内置的 pip 版本升级至 26.0.1

* gh-144493: Improve an exception error message in
  "_overlapped.BindLocal()" that is raised when
  "asyncio.loop.sock_connect()" is called on a
  "asyncio.ProactorEventLoop" with a socket that has an invalid
  address family.

* gh-144386: Add support for arbitrary descriptors "__enter__()",
  "__exit__()", "__aenter__()", and "__aexit__()" in
  "contextlib.ExitStack" and "contextlib.AsyncExitStack", for
  consistency with the "with" and "async with" statements.

* gh-123471: Make concurrent iteration over
  "itertools.combinations_with_replacement" and
  "itertools.permutations" safe under free-threading.

* gh-74453: Deprecate "os.path.commonprefix()" in favor of
  "os.path.commonpath()" for path segment prefixes.

  The "os.path.commonprefix()" function is being deprecated due to
  having a misleading name and module. The function is not safe to use
  for path prefixes despite being included in a module about path
  manipulation, meaning it is easy to accidentally introduce path
  traversal vulnerabilities into Python programs by using this
  function.

* gh-144380: 将 "io.BufferedReader" 行迭代的性能提升 ~49%。

* gh-144363: 将捆绑的 libexpat 更新至 2.7.4

* gh-140824: When "faulthandler" dumps the list of third-party
  extension modules, ignore sub-modules of stdlib packages. Patch by
  Victor Stinner.

* gh-144206: Improve error messages for buffer overflow in
  "fcntl.fcntl()" and "fcntl.ioctl()".

* gh-144264: Speed up Base64 decoding of data containing ignored
  characters (both in non-strict mode and with an explicit
  *ignorechars* argument). It is now up to 2 times faster for
  multiline Base64 data.

* gh-144249: Add filename context to "OSError" exceptions raised by
  "ssl.SSLContext.load_cert_chain()", allowing users to have more
  context.

* gh-132888: Fix incorrect use of "ctypes.GetLastError()" and add
  missing error checks for Windows API calls in
  "_pyrepl.windows_console".

* gh-142956: Updated "tomllib" to parse TOML 1.1.0.

* gh-144217: "mimetypes": Add support for DICOM files (for medical
  imaging) with the official MIME type "application/dicom". Patch by
  Benedikt Johannes.

* gh-144212: Mime type "image/jxl" is now supported by "mimetypes".

* gh-143594: Add "symtable.Function.get_cells()" and
  "symtable.Symbol.is_cell()" methods.

* gh-144169: 修复向 "ast" 模块中的对象提供非字符串关键字参数时的三个崩
  溃问题。

* gh-144128: Fix a crash in "array.array.fromlist()" when an element's
  "__index__()" method mutates the input list during conversion.

* gh-144100: 修复在 "argtypes" 中使用已弃用的 "POINTER(str)" 类型时
  ctypes 中的崩溃问题。当指针目标类型未解析时，ctypes 现在会引发正确的
  Python 异常而不是中止程序。

* gh-143658: "importlib.metadata": Use "str.lower()" and
  "str.replace()" to further improve performance of
  "importlib.metadata.Prepared.normalize()". Patch by Hugo van
  Kemenade and Henry Schreiner.

* gh-144050: 修正纯 Python 实现中的 "stat.filemode()" 以避免将无效的模
  式值误分类为块设备。

* gh-83069: "subprocess.Popen.wait()": when "timeout" is not "None",
  an efficient event-driven mechanism now waits for process
  termination, if available. Linux >= 5.3 uses "os.pidfd_open()" +
  "select.poll()". macOS and other BSD variants use "select.kqueue()"
  + "KQ_FILTER_PROC" + "KQ_NOTE_EXIT". Windows keeps using
  "WaitForSingleObject" (unchanged). If none of these mechanisms are
  available, the function falls back to the traditional busy loop
  (non-blocking call and short sleeps). Patch by Giampaolo Rodola.

* gh-144030: The Python implementation of "functools.lru_cache()"
  differed from the default C implementation in that it did not check
  that its argument is callable. This discrepancy is now fixed and
  both raise a "TypeError".

* gh-144001: Added the *ignorechars* parameter in
  "binascii.a2b_base64()" and "base64.b64decode()".

* gh-144023: 修复 posix 函数在附带 follow_symlinks 形参使用时文件描述
  符 0 的验证问题。

* gh-143999: 修复 "inspect.getgeneratorstate()" 和
  "inspect.getcoroutinestate()" 对以 "types.coroutine()" 包装的生成器
  处于挂起状态时可能执行失败的问题。

* gh-143952: Fixed "asyncio" debugging tools to work with new remote
  debugging API. Patch by Bartosz Sławecki.

* gh-143904: "struct.pack_into()" now raises OverflowError instead of
  IndexError for too large *offset* argument.

* gh-143897: Remove the "isxidstart()" and "isxidcontinue()" methods
  of "unicodedata.ucd_3_2_0". They are now only exposed as
  "unicodedata.isxidstart()" and "unicodedata.isxidcontinue()".

* gh-143831: 从带有闭包的标注作用域创建的 "annotationlib.ForwardRef"
  对象现在可哈希。此前，对此类对象进行哈希会抛出异常。由 Bartosz
  Sławecki 编写补丁。

* gh-143874: 修复 "pdb" 中表达式结果未发送回远程客户端的程序缺陷。

* gh-143754: Add new "tkinter" widget methods "pack_content()",
  "place_content()" and "grid_content()" which are alternative
  spelling of old "*_slaves()" methods.

* gh-143756: Fix potential thread safety issues in "ssl" module.

* gh-132604: Previously, "Protocol" classes that were not decorated
  with "@~typing.runtime_checkable", but that inherited from another
  "Protocol" class that did have this decorator, could be used in
  "isinstance()" and "issubclass()" checks. This behavior is now
  deprecated and such checks will throw a "TypeError" in Python 3.20.
  Patch by Bartosz Sławecki.

* gh-143543: 修复 itertools.groupby 中当用户定义的 "__eq__()" 方法在键
  比较期间重进入迭代器时可能发生的崩溃问题。

* gh-143689: Fix "io.BufferedReader.read1()" state cleanup on buffer
  allocation failure.

* gh-143602: 修复 "write()" 中通过去重缓冲区导出导致意外缓冲区覆盖的不
  一致性问题。

* gh-142434: Use "ppoll()" if available in "select.poll()" to have a
  timeout resolution of 1 nanosecond, instead of a resolution of 1 ms.
  Patch by Victor Stinner.

* gh-140557: "array.array" buffers now have the same alignment when
  empty as when allocated. Unaligned buffers can still be created by
  slicing.

* gh-143423: Fix free-threaded build detection in the sampling
  profiler when Py_GIL_DISABLED is set to 0.

* gh-101178: Add Ascii85, Base85, and Z85 support to "binascii" and
  improve the performance of the base-85 converters in "base64".

* gh-142966: Fix "ctypes.POINTER.set_type()" not updating the format
  string to match the type.

* gh-142555: "array": 修复在 "a[i] = v" 中当通过 "i.__index__" 或
  "i.__float__" 将 *i* 转换为索引对数组进行修改时的崩溃问题。

* gh-142438: Fix _decimal builds configured with EXTRA_FUNCTIONALITY
  by correcting the Context.apply wrapper to pass the right argument.

* gh-141860: Add an "on_error" keyword-only parameter to
  "multiprocessing.set_forkserver_preload()" to control how import
  failures during module preloading are handled. Accepts "'ignore'"
  (default, silent), "'warn'" (emit "ImportWarning"), or "'fail'"
  (raise exception). Contributed by Nick Neumann and Gregory P. Smith.

* gh-125346: Accepting "+" and "/" characters with an alternative
  alphabet in "base64.b64decode()" and "base64.urlsafe_b64decode()" is
  now deprecated. In future Python versions they will be errors in the
  strict mode and discarded in the non-strict mode.

* gh-140715: Add "'%F'" support to "strptime()".

* gh-67041: Add the *missing_as_none* parameter to "urlparse()",
  "urlsplit()" and "urldefrag()" functions. Add the *keep_empty*
  parameter to "urlunparse()" and "urlunsplit()" functions. This
  allows to distinguish between empty and not defined URI components
  and preserve empty components.

* gh-77188: The "pickle" module now properly handles name-mangled
  private methods.


IDLE
----

* gh-143774: 更好地解释"格式 / 格式化段落"的操作。


核心与内置函数
--------------

* gh-134584: Optimize and eliminate ref-counting in
  "_BINARY_OP_SUBSCR_LIST_SLICE"

* gh-144563: Fix interaction of the Tachyon profiler and "ctypes" and
  other modules that load the Python shared library (if present) in an
  independent map as this was causing the mechanism that loads the
  binary information to be confused. Patch by Pablo Galindo

* gh-144601: Fix crash when importing a module whose "PyInit" function
  raises an exception from a subinterpreter.

* gh-144549: Fix building the tail calling interpreter on Visual
  Studio 2026 with free-threading.

* gh-144513: 修复自由线程构建版中当在 stop-the-world 暂停期间使用关键
  节时潜在的死锁问题。

* gh-131798: Optimise "_GUARD_TOS_SLICE" in the JIT.

* gh-144330: Move "classmethod" and "staticmethod" initialization from
  "__init__()" to "__new__()". Patch by Victor Stinner.

* gh-144446: 修复自由线程构建版中当另一个线程正在执行帧时读取帧对象属
  性导致的数据竞争问题。

* gh-120321: Add "gi_state", "cr_state", and "ag_state" attributes to
  generators, coroutines, and async generators that return the current
  state as a string (e.g., "GEN_RUNNING"). The "inspect" module
  functions "getgeneratorstate()", "getcoroutinestate()", and
  "getasyncgenstate()" now return these attributes directly.

* gh-141563: Fix thread safety of " PyDateTime_IMPORT".

* gh-144280: Fix a bug in JIT where the predicate symbol had no
  truthiness

* gh-140550: In "PyModuleDef.m_slots", allow slots that repeat
  information present in "PyModuleDef".

* gh-139103: Improve scaling of "namedtuple()" instantiation in the
  free-threaded build.

* gh-144307: 在解释器最终化时防止模块卸载中的引用泄漏问题。

* gh-144319: Add huge pages support for the pymalloc allocator. Patch
  by Pablo Galindo

* gh-120321: Made "gi_yieldfrom" thread-safe in the free-threading
  build by using a lightweight lock on the frame state.

* gh-144194: 修复内存分配失败时 perf jitdump 初始化中的错误处理。

* gh-143962: Name suggestion for not normalized name suggests now the
  normalized name or the closest name to the normalized name. If the
  suggested name is not ASCII, include also its ASCII representation.

* gh-144157: "bytes.translate()" now allows the compiler to unroll its
  loop more usefully for a 2x speedup in the common no-deletions
  specified case.

* gh-144068: Fix JIT tracer memory leak, ensure the JIT tracer state
  is freed when daemon threads are cleaned up during interpreter
  shutdown.

* gh-144012: 在 "BINARY_OP_EXTENT" 操作码中检查结果是否为 "NULL"。

* gh-144007: Eliminate redundant refcounting in the JIT for
  "BINARY_OP".

* gh-144005: Eliminate redundant refcounting from "BINARY_OP_EXTEND".

* gh-143939: Fix erroneous "cannot reuse already awaited coroutine"
  error that could occur when a generator was run during the process
  of clearing a coroutine's frame.

* gh-141805: 修复在移除具有相同哈希值的元素后、集合中仍包含具有相同哈
  希值的元素的情况下并发向 "set" 中添加具有相同哈希值的对象时的崩溃问
  题。

* gh-143670: 修复 "ga_repr_items_list" 函数中的崩溃问题。

* gh-143650: 修复 "importlib" 中一个线程在另一个线程的导入失败时可能接
  收到过期的模块引用导致的竞争条件问题。

* gh-143569: Generator expressions in 3.15 now conform to the
  documented behavior when the iterable does not support iteration.
  This matches the behavior in 3.14 and earlier

* gh-143192: Improve performance of bitwise operations on multi-digit
  ints.

* gh-132657: If we are specializing to "LOAD_GLOBAL_MODULE" or
  "LOAD_ATTR_MODULE", try to enable deferred reference counting for
  the value, if the object is owned by a different thread.  This
  applies to the free-threaded build only and should improve scaling
  of multi-threaded programs. Note that when deferred reference
  counting is enabled, the object will be deallocated by the GC,
  rather than by "Py_DECREF()".

* gh-143055: Implement **PEP 798** (Unpacking in Comprehensions).
  Patch by Adam Hartz.

* gh-142037: Improve error messages for printf-style formatting. For
  errors in the format string, always include the position of the
  start of the format unit. For errors related to the formatted
  arguments, always include the number or the name of the argument.
  Raise more specific errors and include more information (type and
  number of arguments, most probable causes of error).

* gh-140557: "bytearray" buffers now have the same alignment when
  empty as when allocated. Unaligned buffers can still be created by
  slicing.

* gh-140232: Frozenset objects with immutable elements are no longer
  tracked by the garbage collector.

* gh-115231: Setup "__module__" attribute for built-in static methods.
  Patch by Sergey B Kirpichev.


C API
-----

* gh-143869: Added "PyLong_GetNativeLayout()", "PyLongLayout",
  "PyLongExport", "PyLong_Export()", "PyLong_FreeExport()",
  "PyLongWriter", "PyLongWriter_Create()", "PyLongWriter_Finish()" and
  "PyLongWriter_Discard()" to the limited API.

* gh-141070: Renamed "PyUnstable_Object_Dump()" to "PyObject_Dump()".


构建
----

* gh-140421: Disable the perf trampoline on older macOS versions where
  it cannot be built.

* gh-144309: Build Python with POSIX 2024, instead of POSIX 2008.
  Patch by Victor Stinner.

* gh-144278: Enables defining the "_PY_IMPL_NAME" and
  "_PY_IMPL_CACHE_TAG" preprocessor definitions to override
  "sys.implementation" at build time. Definitions need to include
  quotes when setting to a string literal. Setting the cache tag to
  "NULL" has the effect of completely disabling automatic creation and
  use of ".pyc" files.

* gh-143960: Add support for OpenSSL 3.6, drop EOL 3.2. Patch by Hugo
  van Kemenade.

* gh-143941: Move WASI-related files to "Platforms/WASI". Along the
  way, leave a deprecated "Tools/wasm/wasi/__main__.py" behind for
  backwards-compatibility.

* gh-143842: Prevent static builds from clashing with curses by making
  the optimizer COLORS table static.


Python 3.15.0 alpha 5
=====================

*Release date: 2026-01-14*


Windows
-------

* gh-143082: Fix "pdb" arrow key history not working when "stdin" is
  "sys.stdin".

* gh-128067: 修复 Windows 上的 PyREPL 中不带末尾换行符的输出会被下一个
  提示符覆盖的程序缺陷。


工具/示例
---------

* gh-142095: 在可能的情况下让 gdb 'py-bt' 命令使用来自线程局部状态的帧
  。 由 Sam Gross 和 Victor Stinner 编写补丁。


测试
----

* gh-143460: 如果栈大小没有限制则将跳过依赖于无限递归的测试。

* gh-143553: 增加对参数化资源的支持，如 "-u xpickle=2.7"。

* bpo-31391: 将 test_xpickle 从 Python 2 前向移植到 Python 3 并将资源
  添加回测试的命令行。


库
--

* gh-143706: 修复 "multiprocessing" forkserver 以便在预加载 "__main__"
  之前正确设置 "sys.argv"。此前，forkserver 子进程中在主模块导入期间
  "sys.argv" 是空的。这修复了 3.13.8 和 3.14.1 中引入的回归问题。由
  Aaron Wieczorek 根本定位，由 Thomas Watson 提供测试，感谢！

* gh-143638: 禁止 C 实现中 "pickle.Pickler" 和 "pickle.Unpickler" 方法
  的重入调用。此前，这可能会导致崩溃或数据损坏，现在对同一对象的方法进
  行并发调用将引发 "RuntimeError"。

* gh-143658: "importlib.metadata": Use "str.translate()" to improve
  performance of "importlib.metadata.Prepared.normalize()". Patch by
  Hugo van Kemenade and Henry Schreiner.

* gh-78724: 当用户尝试调用半初始化的 "Struct" 对象（例如由
  "Struct.__new__(Struct)" 创建的对象）的方法时引发 "RuntimeError"。由
  Sergey B Kirpichev 编写补丁。

* gh-143196: 修复由未文档化函数 "json.encoder.c_make_encoder()" 返回的
  内部编码器对象在附带非零第二个参数 (*_current_indent_level*) 调用时
  的崩溃问题。

* gh-143191: 如果栈大小过小，"_thread.stack_size()" 现在将引发
  "ValueError"。由 Victor Stinner 编写补丁。

* gh-143547: 修复当钩子引发异常并更改 "sys.unraisablehook()" 时的
  "sys.unraisablehook()": 持有对旧钩子的强引用。由 Victor Stinner 编写
  补丁。

* gh-139686: Revert 0a97941245f1dda6d838f9aaf0512104e5253929 and
  57db12514ac686f0a752ec8fe1c08b6daa0c6219 which made importlib.reload
  a no-op for lazy modules; caused Buildbot failures.

* gh-143517: 当求值以一个或多个空白字符后跟 "*" 开头的字符串化星号标注
  时，"annotationlib.get_annotations()" 不再引发 "SyntaxError"。由
  Bartosz Sławecki 编写补丁。

* gh-143474: Add "os.RWF_ATOMIC" constant for Linux 6.11+.

* gh-143445: Speed up "copy.deepcopy()" by 1.04x.

* gh-143378: 修复在 "write()" 或 "writelines()" 期间并发修改 "BytesIO"
  对象时的释放后使用崩溃问题。

* gh-143368: Fix endless retry loop in "profiling.sampling" blocking
  mode when threads cannot be seized due to "EPERM". Such threads are
  now skipped instead of causing repeated error messages. Patch by
  Pablo Galindo.

* gh-143346: 修复当缩进包含制表符和空格混合时 "plistlib._PlistWriter"
  中 Base64 数据的错误换行问题。

* gh-140025: "queue": Fix "SimpleQueue.__sizeof__()" computation.

* gh-143310: "tkinter": 修复在将 Python "list" 转换为 Tcl 对象时 (例如
  在设置 Tcl 变量时) 如果其被修改则会造成程序崩溃的问题。 由 Bénédikt
  Tran 编写补丁。

* gh-143309: 修复在非 Windows 平台上当给定一个在解析期间被修改的自定义
  环境映射时 "os.execve()" 中的崩溃问题。由 Bénédikt Tran 编写补丁。

* gh-143308: "pickle": 修复在 pickle 期间自定义缓冲区回调并发修改
  "PickleBuffer" 时的释放后使用崩溃问题。由 Bénédikt Tran 和 Aaron
  Wieczorek 编写补丁。

* gh-142939: Performance optimisations for
  "difflib.get_close_matches()"

* gh-124951: The base64 implementation behind the "binascii",
  "base64", and related codec has been optimized for modern pipelined
  CPU architectures and now performs 2-3x faster across all platforms.

* gh-143237: 修复 "logging" 滚动处理器中对命名管道的支持。

* gh-143249: 修复 Windows 重叠 I/O 在错误处理时可能的缓冲区泄漏问题。

* gh-143241: "zoneinfo": 修复解析格式错误的 TZif 文件时
  "ZoneInfo.from_file" 中的无限循环问题。由 Fatih Celik 编写补丁。

* gh-142830: "sqlite3": 修复在回调执行期间修改连接的回调时的释放后使用
  崩溃问题。由 Bénédikt Tran 编写补丁。

* gh-143200: "xml.etree.ElementTree": 修复当元素被并发修改时 "Element"
  的 "__getitem__()" 和 "__setitem__()" 方法中的释放后使用崩溃问题。由
  Bénédikt Tran 编写补丁。

* gh-143214: Add the *wrapcol* parameter in "binascii.b2a_base64()"
  and "base64.b64encode()".

* gh-142195: 更新 "subprocess" 中的超时评估逻辑，使其兼容像 Shadow 这
  样时间完全按请求推进的确定性环境。

* gh-140739: Fix several crashes due to reading invalid memory in the
  new Tachyon sampling profiler. Patch by Pablo Galindo.

* gh-142164: 修复 ctypes 位域溢出错误消息以报告正确的偏移量和大小计算
  。

* gh-143145: 修复 ctypes 在出错时使用多个输出参数构造结果时可能的引用
  泄漏问题。

* gh-143103: Add padding support to "base64.z85encode()" via the "pad"
  parameter.

* gh-130796: Undeprecate the "locale.getdefaultlocale()" function.
  Patch by Victor Stinner.

* gh-74902: Add the "iter_graphemes()" function in the "unicodedata"
  module to iterate over grapheme clusters according to rules defined
  in Unicode Standard Annex #29, "Unicode Text Segmentation". Add
  "grapheme_cluster_break()", "indic_conjunct_break()" and
  "extended_pictographic()" functions to get the properties of the
  character which are related to the above algorithm.

* gh-143004: 修复当用户代码在更新期间修改 Counter 时
  "collections.Counter.update()" 中潜在的释放后使用问题。

* gh-140648: "asyncio" REPL 现在遵守 "-I" 标志（隔离模式）。此前，即使
  设置了该标志，它也会加载并执行 "PYTHONSTARTUP"。由 Bartosz Sławecki
  贡献。

* gh-142991: 修复 FreeBSD divert(4) 套接字的 recvfrom() 和 sendto() 等
  套接字操作。

* gh-116738: Make the attributes in "lzma" thread-safe on the *free
  threaded* build.

* gh-142950: Fix regression in "argparse" where format specifiers in
  help strings raised "ValueError".

* gh-142881: 修复 "atexit.unregister()" 的并发和重入调用问题。

* gh-142615: Fix possible crashes when initializing "asyncio.Task" or
  "asyncio.Future" multiple times. These classes can now be
  initialized only once and any subsequent initialization attempt will
  raise a RuntimeError. Patch by Kumar Aditya.

* gh-142517: 非 "compat32" 的 "email" 策略现在可正确处理包含无法在其指
  定字符集中解码的字节的编码字的重新折叠。此前这会在折叠期间导致编码异
  常。

* gh-138122: The Tachyon profiler's live TUI now integrates with the
  experimental "_colorize" theming system. Users can customize colors
  via "_colorize.set_theme()" (experimental API, subject to change). A
  "LiveProfilerLight" theme is provided for light terminal
  backgrounds. Patch by Pablo Galindo.

* gh-142306: Improve errors for "Element.remove".

* gh-63016: Add a "flags" parameter to "mmap.mmap.flush()" to control
  synchronization behavior.

* gh-139262: Windows 上新的 "PyREPL" 中某些按键可能被吞掉，特别是与
  ALT 键一起使用时。由 Chris Eibl 修复。

* gh-138897: 改进 *REPL* 中 "license"/"copyright"/"credits" 的显示：现
  在使用分页器。

* gh-135852: Add "_winapi.RegisterEventSource()",
  "_winapi.DeregisterEventSource()" and "_winapi.ReportEvent()". Using
  these functions in "NTEventLogHandler" to replace "pywin32".

* gh-109263: 从 "multiprocessing" 中的 spawn 上下文启动进程时不再全局
  设置启动方法。

* gh-132715: 一旦发生失败，跳过在 marshal 期间写入对象。


文档
----

* gh-140806: 增加 "enum.bin()" 的文档。


核心与内置函数
--------------

* gh-134584: Eliminate redundant refcounting from "_CONTAINS_OP",
  "_CONTAINS_OP_SET" and "_CONTAINS_OP_DICT".

* gh-143604: Fix a reference counting issue in the JIT tracer where
  the current executor could be prematurely freed during tracing.

* gh-143469: Enable "LOAD_ATTR_MODULE" specialization even if
  "__getattr__()" is defined in module.

* gh-134584: Eliminate redundant refcounting from "TO_BOOL_STR".

* gh-143377: 修复异常格式不正确时 "_interpreters.capture_exception()"
  中的崩溃问题。由 Bénédikt Tran 编写补丁。

* gh-139757: Add "BINARY_OP_SUBSCR_USTR_INT" to specialize reading an
  ASCII character from any string. Patch by Chris Eibl.

* gh-141504: Factor out tracing and optimization heuristics into a
  single object. Patch by Donghee Na.

* gh-142982: Specialize "CALL_FUNCTION_EX" for Python and non-Python
  callables.

* gh-136924: *REPL* 中的交互式帮助模式不再错误地将文本输入作为 Python
  代码进行语法高亮。由 Olga Matoula 贡献。

* gh-139757: Fix unintended bytecode specialization for non-ascii
  string. Patch by Donghee Na, Ken Jin and Chris Eibl.

* gh-143361: Add "PY_VECTORCALL_ARGUMENTS_OFFSET" to
  "_Py_CallBuiltinClass_StackRefSteal" to avoid redundant allocations

* gh-131798: The JIT optimizer now understands more generator
  instructions.

* gh-134584: Eliminate redundant refcounting from "_LOAD_ATTR_SLOT".

* gh-143189: 修复当将非 "str" 键插入拆分表字典时，如果该键与拆分表中现
  有键匹配但在字典中没有对应值时的崩溃问题。

* gh-143228: 修复在线程运行时切换性能分析或在守护线程活动期间进行解释
  器终结时 perf trampoline 中的释放后使用问题。此修复使用引用计数来确
  保在任何代码对象仍可能引用 trampoline 时不会释放它们。由 Pablo
  Galindo 编写补丁。

* gh-142664: 修复当被引用对象的 "__hash__" 方法修改该对象或视图时
  "memoryview.__hash__" 中的释放后使用崩溃问题。由 Bénédikt Tran 编写
  补丁。

* gh-142557: 修复在格式化 "%" 风格参数时 "bytearray" 被修改时
  bytearray.__mod__ 中的释放后使用崩溃问题。由 Bénédikt Tran 编写补丁
  。

* gh-143195: 修复当分隔符的 "__len__()" 修改原始对象时
  "bytearray.hex()" 和 "memoryview.hex()" 中的释放后使用崩溃问题。由
  Bénédikt Tran 编写补丁。

* gh-143183: Fix a bug in the JIT when dealing with unsupported
  control-flow or operations.

* gh-142975: 修复在 *free threaded* 构建版本中解冻垃圾回收器跟踪的所有
  对象后的崩溃问题。

* gh-143135: 当 "PYTHONINSPECT" 为 "0" 时将 "sys.flags.inspect" 设置为
  "1"。此前，在这种情况下它被设置为 "0"。

* gh-143123: Protect the JIT against recursive tracing.

* gh-143092: Fix a crash in the JIT when dealing with "list.append(x)"
  style code.

* gh-143003: 修复当 "__length_hint__()" 对非空迭代器返回 0 时
  "bytearray.extend()" 中共享空缓冲区的溢出问题。

* gh-143006: 修复比较整数部分具有相同位数的负非整数 "float" 和 "int"
  时可能的断言错误。

* gh-116738: Fix thread safety of "contextvars.Context.run()".

* gh-142829: 修复当自定义 "__eq__" 方法通过 "set()" 修改上下文时
  "contextvars.Context" 比较中的释放后使用崩溃问题。

* gh-142863: Generate optimized bytecode when calling "list" or "set"
  with generator expression.

* gh-41779: Allowed defining any __slots__ for a class derived from
  "tuple" (including classes created by "collections.namedtuple()").

* gh-69605: 修正在 modules in the *REPL* 自动补全导入功能中已导入模块
  的边界情况问题。

* gh-138568: 调整内置 "help()" 函数以在交互模式下忽略空输入。

* gh-131798: Remove bounds check when indexing into tuples with a
  constant index.

* gh-134584: Eliminate redundant refcounting from "_CALL_TYPE_1".
  Patch by Tomas Roun

* gh-132108: Speed up "int.from_bytes()" when passed object supports
  buffer protocol, like "bytearray" by ~1.2x.

* gh-128334: Make the "slice" class subscriptable at runtime to be
  consistent with typing implementation.


C API
-----

* gh-141671: "PyMODINIT_FUNC" (and the new "PyMODEXPORT_FUNC") now
  adds a linkage declaration ("__declspec(dllexport)") on Windows.


Python 3.15.0 alpha 4
=====================

*Release date: 2026-01-13*


测试
----

* gh-142836: 在 "test_pdb.test_script_target_anonymous_pipe" 中支持
  Solaris。


库
--

* gh-122431: 修正 "readline.append_history_file()" 中的错误消息以指明
  "nelements" 必须是非负数而不是正数。

* gh-143046: "asyncio" REPL 在静默模式下 ("-q") 将不再打印版权和版本消
  息。 由 Bartosz Sławecki 编写补丁。

* gh-80744: Fix issue where "pdb" would read a ".pdbrc" twice if
  launched from the home directory

* gh-138122: Add blocking mode to Tachyon for accurate stack traces in
  applications with many generators or fast-changing call stacks.
  Patch by Pablo Galindo.

* gh-143010: 修复 "mailbox" 中的一个程序缺陷，外部事件的精确时机可能导
  致库打开一个现有文件而不是它期望创建的文件。

* gh-112127: 修复在比较期间取消注册回调时 "atexit.unregister()" 中可能
  的释放后使用问题。

* gh-138122: Fix incomplete stack traces in the Tachyon profiler's
  frame cache when profiling code with deeply nested generators. The
  frame cache now validates that stack traces reach the base frame
  before caching, preventing broken flamegraphs. Patch by Pablo
  Galindo.

* gh-142834: Change the "pdb" "commands" command to use the last
  available breakpoint instead of failing when the most recently
  created breakpoint was deleted.

* gh-142783: 修复 zoneinfo 中描述器 _weak_cache 的释放后使用问题。描述
  器作为 _weak_cache 可能在对象创建期间导致崩溃。此修复确保对描述器提
  供的对象进行正确的引用计数。

* gh-76007: Deprecate "VERSION" from "xml.etree.ElementTree" and
  "version" from "xml.sax.expatreader" and "xml.sax.handler". Patch by
  Hugo van Kemenade.

* gh-142784: "asyncio" REPL 现在在交互式会话结束时正确关闭循环。此前，
  这可能会导致意外的警告。由 Bartosz Sławecki 贡献。

* gh-138122: Add binary output format to "profiling.sampling" for
  compact storage of profiling data. The new "--binary" option
  captures samples to a file that can be converted to other formats
  using the "replay" command. Patch by Pablo Galindo

* gh-142495: "collections.defaultdict" 现在在从 "default_factory" 插入
  默认值时优先使用 "__setitem__()"。这可以防止默认值覆盖在
  "default_factory" 返回之前设置的值的竞争条件。

* gh-142654: Show the clearer error message when using
  "profiling.sampling" on an unknown PID.

* gh-142560: 通过将存储标记为已导出 (这会导致重新分配尝试引发
  "BufferError") 修复 "bytearray" 搜索类方法 ("find()"、"count()"、
  "index()"、"rindex()" 和 "rfind()") 中的释放后使用问题。 对于
  "contains()"、"split()" 和 "rsplit()"，为此使用 buffer protocol。

* gh-142419: "mmap.mmap.set_name()" method added to annotate an
  anonymous memory map if Linux kernel supports "PR_SET_VMA_ANON_NAME"
  (Linux 5.17 or newer). Patch by Donghee Na.

* gh-139971: "pydoc": 确保 *stdlib* 模块的在线文档链接正确。

* gh-124098: Fix issue where methods in handlers that lacked the
  protocol name but matched a valid base handler method (e.g.,
  "_open()" or "error()") were incorrectly added to
  "urllib.request.OpenerDirector"'s handlers. Contributed by Andrea
  Mattei.

* gh-136282: 增加通过映射协议访问创建节时对 "UNNAMED_SECTION" 的支持。


核心与内置函数
--------------

* gh-143057: 当 "tracemalloc" 未启用时避免在 "PyTraceMalloc_Track()"
  和 "PyTraceMalloc_Untrack()" 中加锁。

* gh-139109: Add missing terminator in certain cases when tracing in
  the new JIT compiler.

* gh-142961: Fix a segfault in the JIT when constant folding
  "len(tuple)".

* gh-142776: 修复 import.c 中的文件描述符泄漏问题。

* gh-139757: Fix building JIT stencils on free-threaded builds.

* gh-129068: Make concurrent iteration over the same range iterator
  thread-safe in the free threading build.

* gh-142543: Fix a stack overflow on Clang JIT build configurations
  with full LTO.

* gh-142448: Fix a bug when using monitoring with the JIT.

* gh-142766: 当 "generator.close()" 被调用时清除生成器的帧。

* gh-134584: Eliminate redundant refcounting from
  "_LOAD_ATTR_INSTANCE_VALUE".

* gh-134584: Eliminate redundant refcounting from
  "_STORE_ATTR_WITH_HINT".

* gh-142476: Fix a memory leak in the experimental Tier 2 optimizer
  when creating executors. Patched by Shamil Abdulaev.

* gh-100964: 修复已耗尽生成器帧中的引用循环问题。由 Savannah Ostrowski
  编写补丁。

* gh-139922: Allow building CPython with the tail calling interpreter
  on Visual Studio 2026 MSVC. This provides a performance gain over
  the prior interpreter for MSVC. Patch by Ken Jin, Brandt Bucher, and
  Chris Eibl. With help from the MSVC team including Hulon Jenkins.


Python 3.15.0 alpha 3
=====================

*Release date: 2025-12-16*


工具/示例
---------

* gh-141692: 现在 iOS XCframework 的每个切片都包含一个 "lib" 文件夹，
  其中包含指向 libpython dylib 的符号链接。 这允许为 iOS 编译二进制模
  块时使用动态库链接，而不是 Framework 链接。


测试
----

* gh-140381: Fix flaky test_profiling tests on i686 and s390x
  architectures by increasing slow_fibonacci call frequency from every
  5th iteration to every 2nd iteration.

* gh-140210: Make "test_sysconfig.test_parse_makefile_renamed_vars"
  less fragile by clearing the environment variables before parsing
  the Makefile.


安全性
------

* gh-142145: 移除 "xml.minidom" 节点 ID 缓存清理中的二次方增长行为。

* gh-42400: Fix buffer overflow in "_Py_wrealpath()" for paths
  exceeding "MAXPATHLEN" bytes by using dynamic memory allocation
  instead of fixed-size buffer. Patch by Shamil Abdulaev.

* gh-119451: 修正 "http.client" 模块中一个潜在的内存拒绝服务问题。 当
  连接到一个恶意服务器时，它可能导致分配任意大小的内存。 这会造成多种
  问题包括 "MemoryError"、消耗交换空间、内存不足（OOM）杀死进程或容器
  ，甚至系统崩溃。

* gh-119342: 修正a potential memory denial of service in the
  "plistlib" 模块中一个潜在的内存拒绝服务问题。 当读取从不受信任的源接
  收的 Plist 文件时，它可能导致分配任意大小的内存。 这会造成多种问题包
  括 "MemoryError"、消耗交换空间、内存不足（OOM）杀死进程或容器，甚至
  系统崩溃。


库
--

* gh-142754: 为通过直接实例化 "Element" 或 "Attr" 类创建的
  "xml.dom.minidom" 元素和属性添加 *ownerDocument* 属性。请注意这种创
  建节点的方式不受支持；应改用像 "xml.dom.Document.documentElement()"
  这样的创建器函数。

* gh-142594: 修复当底层缓冲区的 "closed" 属性调用 "detach()" 时
  "TextIOWrapper.close()" 中的崩溃问题。

* gh-76007: Deprecate "__version__" from "ctypes". Patch by Hugo van
  Kemenade.

* gh-76007: Deprecate "__version__" from "wsgiref.simple_server".
  Patch by Hugo van Kemenade.

* gh-142651: "unittest.mock": 修复当 mock 从多个线程并发调用时
  "Mock.call_count" 可能返回不准确值的线程安全问题。

* gh-76007: Deprecate "__version__" from "http.server". Patch by Hugo
  van Kemenade.

* gh-138122: Add "--subprocesses" flag to "profiling.sampling" CLI to
  automatically profile subprocesses spawned by the target. When
  enabled, the profiler monitors for new Python subprocesses and
  profiles each one separately, writing results to individual output
  files. This is useful for profiling applications that use
  "multiprocessing", "ProcessPoolExecutor", or other subprocess-based
  parallelism. Patch by Pablo Galindo.

* gh-142595: 在 "decimal" 模块初始化期间增加类型检查以防止标准库损坏时
  的崩溃。由 Sergey B Kirpichev 编写补丁。

* gh-142556: 修复在 "asyncio" 中执行最终化期间有任务被重新注册时导致的
  崩溃问题。 由 Kumar Aditya 编写补丁。

* gh-138122: Add "--mode=exception" to the sampling profiler to
  capture samples only from threads with an active exception, useful
  for analyzing exception handling overhead. Patch by Pablo Galindo.

* gh-142539: "traceback": Fix location of carets in "SyntaxError"s
  when the source contains wide characters.

* gh-123241: 在 "ctypes" 对象的垃圾回收中避免引用计数操作。

* gh-142451: "hmac": correctly copy "HMAC" attributes for objects
  copied through "HMAC.copy()". Patch by Bénédikt Tran.

* gh-138122: The "profiling.sampling" flamegraph profiler now supports
  inverted flamegraph view that aggregates all leaf nodes. In a
  standard flamegraph, if a hot function is called from multiple
  locations, it appears multiple times as separate leaf nodes. In the
  inverted flamegraph, all occurrences of the same leaf function are
  merged into a single aggregated node at the root, showing the total
  hotness of that function in one place. The children of each
  aggregated node represent its callers, making it easier to identify
  which functions consume the most CPU time and where they are called
  from.

* gh-112527: 在 "argparse" 中针对必需选项的帮助文本不再带有 "
  (default: None)" 扩展。

* gh-142438: Fixed a possible leaked GIL in _PySSL_keylog_callback.

* gh-138122: Add bytecode-level instruction profiling to the sampling
  profiler via the new "--opcodes" flag. When enabled, the profiler
  captures which bytecode opcode is executing at each sample,
  including Python 3.11+ adaptive specializations, and visualizes this
  data in the heatmap, flamegraph, gecko, and live output formats.
  Patch by Pablo Galindo

* gh-142389: Add backtick markup support in "argparse" description and
  epilog text to highlight inline code when color output is enabled.

* gh-142346: 修复 "argparse" 中当互斥组前面有位置参数或后面跟有其他可
  选参数或与其他可选参数混合时的用法格式化问题。

* gh-142374: Fix cumulative percentage calculation for recursive
  functions in the new sampling profiler. When profiling recursive
  functions, cumulative statistics (cumul%, cumtime) could exceed 100%
  because each recursive frame in a stack was counted separately. For
  example, a function recursing 500 times in every sample would show
  50000% cumulative presence. The fix deduplicates locations within
  each sample so cumulative stats correctly represent "percentage of
  samples where this function was on the stack". Patch by Pablo
  Galindo.

* gh-142315: Pdb 现在可以从进程替换中使用的匿名管道运行脚本。由
  Bartosz Sławecki 编写补丁。

* gh-64532: Subparser help now includes required optional arguments
  from the parent parser in the usage, making it clearer what
  arguments are needed to run a subcommand. Patch by Savannah
  Ostrowski.

* gh-142207: Fix: profiling.sampling may cause assertion "!(has_gil &&
  gil_requested)"

* gh-142332: 修复 "argparse" 中互斥组中位置参数的用法格式化问题。

* gh-142282: 修复 "winreg.QueryValueEx()" 在竞争条件下意外读取垃圾缓冲
  区的问题。

* gh-142318: Fix typing "'q'" at the help of the interactive tachyon
  profiler exiting the profiler.

* gh-75949: 修复 "argparse" 以在用法行因长度而换行时保留互斥组中的 "|"
  分隔符。

* gh-142267: 通过缓存用于参数验证的格式化器来提高 "argparse" 性能。

* gh-139862: Remove "color" parameter from "argparse.HelpFormatter"
  constructor. Color is controlled by "ArgumentParser".

* gh-68552: "MisplacedEnvelopeHeaderDefect" 和 "Missing header name"
  缺陷现在可正确传递给 "FeedParser" 中 "policy" 的 "handle_defect" 方
  法。

* gh-142206: The resource tracker in the "multiprocessing" module can
  now understand messages from older versions of itself. This avoids
  issues with upgrading Python while it is running. (Note that such
  'in-place' upgrades are not tested.)

* gh-142214: 修复 Python 3.14.1 中 "dataclasses" 与标注相关的两个回归
  问题。

  * 如果使用了 "slots=True" 且 "__init__" 方法没有 "__annotate__" 属性
    (可能是因为使用了 "init=False")，现在不再引发异常。

  * 如果在 "__init__" 方法上请求标注且其中一个字段在类标注中不存在，现
    在不再引发异常。这种情况可能发生在某些动态场景中。

  由 Jelle Zijlstra 提供补丁。

* gh-142203: Remove the *debug_override* parameter from
  "importlib.util.cache_from_source()" which has been deprecated since
  Python 3.5.

* gh-138122: The "_remote_debugging" module now implements frame
  caching in the "RemoteUnwinder" class to reduce memory reads when
  profiling remote processes. When "cache_frames=True", unchanged
  portions of the call stack are reused from previous samples,
  significantly improving profiling performance for deep call stacks.

* gh-116738: 修正在使用子解释器初始化三角函数表时 "cmath" 的数据竞争问
  题。

* gh-141982: Allow "pdb" to set breakpoints on async functions with
  function names.

* gh-74389: 当 "subprocess.Popen" 实例使用的 stdin 被关闭时，现在此错
  误将被 "subprocess.Popen.communicate()" 忽略而不是让该类进入不稳定状
  态。

* gh-87512: 修正在 Windows 上当写入大量输入内容时
  "subprocess.Popen.communicate()" 的超时处理问题。 在之前版本中，在写
  入 stdin 时会忽略超时设置，导致在子进程未快速消费输入内容时此方法无
  限阻塞。 现在 stdin 写入将在后台线程中执行，以允许正确地应用超时设置
  。

* gh-141939: Add color to all interpolated values in "argparse" help,
  like "%(default)s" or "%(choices)s". Patch by Alex Prengère.

* gh-141473: 当 "subprocess.Popen.communicate()" 附带 *input* 和
  *timeout* 被调用并且是在进程死亡之前 "TimeoutExpired" 异常引发之后再
  次被调用时，它将不再会被挂起。

* gh-141999: Correctly allow "KeyboardInterrupt" to stop the process
  when using "profiling.sampling".

* gh-142006: 修复 "email.policy.default" 折叠算法中的一个程序缺陷，该
  缺陷在行恰好结束于 max_line_length 且后跟不可折叠 token 时会错误地产
  生双换行符。

* gh-141968: Remove data copy from "re" compilation of regexes with
  large charsets by using "bytearray.take_bytes()".

* gh-141968: Remove data copy from "encodings.idna" "encode()" and
  "encode()" by using "bytearray.take_bytes()".

* gh-141968: Remove data copy from "codecs" "punycode" encoding by
  using "bytearray.take_bytes()".

* gh-141968: Remove data copy from "wave.Wave_read.readframes()" and
  "wave.Wave_write.writeframes()" by using "bytearray.take_bytes()".

* gh-141968: Remove a data copy from "base64.b32decode()" and
  "base64.b32encode()" by using "bytearray.take_bytes()".

* gh-59000: 修正 "pdb" 在未导入定义类的模块时针对类方法的中断点精确性
  问题。

* gh-116738: 修正自由线程构建版中 "re" 扫描器对象的线程安全问题。

* gh-138122: The "profiling.sampling" flamegraph profiler now displays
  thread status statistics showing the percentage of time threads
  spend holding the GIL, running without the GIL, waiting for the GIL,
  and performing garbage collection. These statistics help identify
  GIL contention and thread behavior patterns. When filtering by
  thread, the display shows per-thread metrics.

* gh-141781: Fixed an issue where pdb.line_prefix assignment was
  ignored if assigned after the module was imported.

* gh-141863: Update 流 to use "bytearray.take_bytes()" for a over 10%
  performance improvement on pyperformance asyncio_tcp benchmark.

* gh-141817: Add "socket.IPV6_HDRINCL" constant.

* gh-105836: 修复 "asyncio.run_coroutine_threadsafe()" 让底层已取消的
  asyncio 任务继续运行的问题。

* gh-141570: 支持让 *file-like object* 在颜色检测
  ("_colorize.can_colorize()") 中从 "fileno()" 引发 "OSError"。 这种情
  况会在 "sys.stdout" 被重定向时发生。

* gh-141679: Add colour to defaults in "argparse" help. Patch by Hugo
  van Kemenade.

* gh-141686: Break reference cycles created by each call to
  "json.dump()" or "json.JSONEncoder.iterencode()".

* gh-141659: 修复 AIX 上来自 "_posixsubprocess" 的无效文件描述符错误。

* gh-141645: Add a new "--live" mode to the tachyon profiler in
  "profiling.sampling" module. This mode consist of a live TUI that
  displays real-time profiling statistics as the target application
  runs, similar to "top". Patch by Pablo Galindo

* gh-141615: Check "stdin" instead of "stdout" for "use_rawinput" in
  "pdb".

* gh-69113: Fix "doctest" to correctly report line numbers for
  doctests in "__test__" dictionary when formatted as triple-quoted
  strings by finding unique lines in the string and matching them in
  the source file.

* gh-141600: 修复 Void Linux 上的 musl 版本检测问题。

* gh-48752: Add "readline.get_pre_input_hook()" function to retrieve
  the current pre-input hook. This allows applications to save and
  restore the hook without overwriting user settings. Patch by Sanyam
  Khurana.

* gh-141565: Add async-aware profiling to the Tachyon sampling
  profiler. The profiler now reconstructs and displays async task
  hierarchies in flamegraphs, making the output more actionable for
  users. Patch by Savannah Ostrowski and Pablo Galindo Salgado.

* gh-60107: Remove a copy from "io.RawIOBase.read()". If the
  underlying I/O class keeps a reference to the mutable memory, raise
  a "BufferError".

* gh-116738: 使 csv 模块在 *自由线程* 构建上线程安全。

* gh-140911: "collections": 确保 "UserString.rindex()" 和
  "UserString.index()" 方法接受 "collections.UserString" 实例作为子参
  数。

* gh-140875: 修复当在 "html.parser.HTMLParser" 中设置
  "convert_charrefs=False" 时对文件结束位置上未关闭字符引用（名称型和
  数字型）的处理问题。

* gh-140677: Add heatmap visualization mode to the Tachyon sampling
  profiler. The new "--heatmap" output format provides a line-by-line
  view showing execution intensity with color-coded samples, inline
  statistics, and interactive call graph navigation between callers
  and callees.

* gh-139946: Distinguish stdout and stderr when colorizing output in
  argparse module.

* gh-76007: "pydoc": Fix "DeprecationWarning" being raised when
  generating doc for *stdlib* modules.

* gh-138697: Fix inferring *dest* from a single-dash long option in
  "argparse". If a short option and a single-dash long option are
  passed to "add_argument()", *dest* is now inferred from the single-
  dash long option.

* gh-138525: Add support for single-dash long options and alternate
  prefix characters in "argparse.BooleanOptionalAction".

* gh-79986: 为 "email" 库增加对 "References" 和 "In-Reply-To" 标头的解
  析支持，将标头内容解析为消息 ID token 的列表。这可以防止它们被错误折
  叠。

* gh-135559: Flag: a "dir()" on a "Flag" enumeration now shows non-
  canonical members. (i.e. aliases).

* gh-134453: 修正 POSIX 平台上 "subprocess.Popen.communicate()" 对于非
  字节形状 "memoryview" 实例的 "input=" 处理。 现在它们会被正确转换为
  字节形状视图而不是截断输入。 Windows 平台不存在此程序缺陷。platforms
  did not have this bug.

* gh-127930: Add "__all__" to "tkinter.simpledialog".

* gh-115952: Fix a potential memory denial of service in the "pickle"
  module. When reading a pickled data received from untrusted source,
  it could cause an arbitrary amount of memory to be allocated, even
  if the code that is allowed to execute is restricted by overriding
  the "find_class()" method. This could have led to symptoms including
  a "MemoryError", swapping, out of memory (OOM) killed processes or
  containers, or even system crashes.

* bpo-40350: Fix support for namespace packages in "modulefinder".


文档
----

* gh-141994: "xml.sax.handler": 在
  "xml.sax.handler.feature_external_ges" 的文档中警告 外部实体攻击 风
  险。 由 Sebastian Pipping 编写补丁。


核心与内置函数
--------------

* gh-134584: Eliminate redundant refcounting from
  "_STORE_ATTR_INSTANCE_VALUE".

* gh-142718: JIT: Fix segfault caused by not flushing the stack to
  memory at side exits.

* gh-142737: 即使 "io.open()" 丢失，回溯信息也将在回退模式下显示。此前
  ，这会导致解释器崩溃。由 Bartosz Sławecki 编写补丁。

* gh-116738: Make the attributes in "bz2" thread-safe on the *free
  threaded* build.

* gh-134584: Eliminate redundant refcounting from "_CALL_LIST_APPEND".

* gh-142554: 修复当 "_pylong.int_divmod()" 没有精确返回长度为 2 的元组
  时 "divmod()" 中的崩溃问题。由 Bénédikt Tran 编写补丁。

* gh-142531: 修复自由线程 GC 性能回归问题。如果有很多未跟踪的元组，GC
  会运行得太频繁，导致性能低下。修复方法是将未跟踪的元组包含在"长寿命"
  对象计数中。由于自由线程 GC 也必须扫描冻结对象，因此现在也包含了冻结
  对象的数量。

* gh-142402: 修复构造 "string.templatelib.Template" 时合并相邻字面量部
  分时的引用计数问题，防止被替换的字符串对象泄漏。

* gh-116738: Make the attributes in "zlib" thread-safe on the *free
  threaded* build.

* gh-142343: 修复 m68k 上由于不正确的汇编约束导致的 SIGILL 崩溃问题。

* gh-142236: Improve the "Perhaps you forgot a comma?" syntax error
  for multi-line string concatenations to point to the last string
  instead of the first, making it easier to locate where the comma is
  missing. Patch by Pablo Galindo.

* gh-142236: Fix incorrect keyword suggestions for syntax errors in
  "traceback". The keyword typo suggestion mechanism would incorrectly
  suggest replacements when the extracted source code was incomplete
  rather than containing an actual typo. Patch by Pablo Galindo.

* gh-142305: Decrease the size of the generated stencils and the
  runtime JIT code. Patch by Diego Russo.

* gh-135379: Implement a limited form of register allocation known as
  "top of stack caching" in the JIT. It works by keeping 0-3 of the
  top items in the stack in registers. The code generator generates
  multiple versions of those uops that do not escape and are
  relatively small. During JIT compilation, the copy that produces the
  least memory traffic is selected, spilling or reloading values when
  needed.

* gh-142276: Fix missing type watcher when promoting attribute loads
  to constants in the JIT. Patch by Ken Jin. Reproducer by Yuancheng
  Jiang.

* gh-142218: 修复使用与现有键匹配的非 "str" 键插入拆分表字典时的崩溃问
  题。

* gh-141976: Check against abstract stack overflow in the JIT
  optimizer.

* gh-97850: Remove all "*.load_module()" usage and definitions from
  the import system and importlib. The method has been deprecated in
  favor of "importlib.abc.Loader.exec_module()" since Python 3.4.

* gh-142048: 修正在自由线程构建版中指数级增加的垃圾回收延迟问题。

* gh-65961: Stop setting "__cached__" on modules.

* gh-141770: Annotate anonymous mmap usage only when supported by the
  Linux kernel and if "-X dev" is used or Python is built in debug
  mode. Patch by Donghee Na.

* gh-142029: Raise "ModuleNotFoundError" instead of crashing when a
  nonexistent module is used as a name in "_imp.create_builtin()".

* gh-142029: Raise "ValueError" instead of crashing when empty string
  is used as a name in "_imp.create_builtin()".

* gh-141976: Protect against specialization failures in the tracing
  JIT compiler for performance reasons.

* gh-141861: Fix invalid memory read in the "ENTER_EXECUTOR"
  instruction.

* gh-141930: 当导入模块时，使用 Python 的常规文件对象以确保完整写入
  ".pyc" 文件否则将引发适当的错误。

* gh-138122: Add incomplete sample detection to prevent corrupted
  profiling data. Each thread state now contains an embedded base
  frame (sentinel at the bottom of the frame stack) with owner type
  "FRAME_OWNED_BY_INTERPRETER". The profiler validates that stack
  unwinding terminates at this sentinel frame. Samples that fail to
  reach the base frame (due to race conditions, memory corruption, or
  other errors) are now rejected rather than being included as
  spurious data.

* gh-120158: 修正当启用或禁用监视事件太多次时的不一致状态问题。

* gh-140638: Expose a ""candidates"" stat in "gc.get_stats()" and
  "gc.callbacks".

* gh-141780: Fix "Py_mod_gil" with API added in **PEP 793**:
  "PyModule_FromSlotsAndSpec()" and "PyModExport" hooks

* gh-141732: 确保针对 "ExceptionGroup" 和 "BaseExceptionGroup" 的
  "__repr__()" 在最初传入其构造器的异常序列后来被修改时不会发生变化。

* gh-140638: Expose a ""duration"" stat in "gc.get_stats()" and
  "gc.callbacks".

* gh-139653: 如果栈指针低于限制指针 *并且* 高于栈基准位置则仅引发
  "RecursionError" 或者触发一个致命错误。 如果在此边界以外则认为没有问
  题。 这将避免当用户空间线程与栈相交换时的误报问题。

* gh-41779: Allowed defining the *__dict__* and *__weakref__*
  __slots__ for any class.

* gh-139103: 在自由线程构建上改进数据类的多线程调节操作。

* gh-141589: Change "backoff counter" to use prime numbers instead of
  powers of 2. Use only 3 bits for "counter" and 13 bits for "value".
  This allows to support values up to 8191. Patch by Mikhail Efimov.

* gh-137007: 修正一个在 JIT 编译期间会导致垃圾回收调试断言失败的程序缺
  陷。

* gh-132657: For the free-threaded build, avoid locking the "set"
  object for the "__contains__" method.

* gh-134584: Eliminate redundant refcounting from "_CALL_STR_1".

* gh-134584: Eliminate redundant refcounting from "_CALL_BUILTIN_O".

* gh-134584: Eliminate redundant refcounting from "_CALL_TUPLE_1".
  Patch by Noam Cohen


C API
-----

* gh-142589: 修正解释器栈中对带标签整数的
  "PyUnstable_Object_IsUniqueReferencedTemporary()" 处理。

* gh-142571: 现在 "PyUnstable_CopyPerfMapFile()" 会在刷新数据之前检查
  打开文件是否成功。

* gh-142225: Fixed the "PyABIInfo_VAR" macro.

* gh-141049: "_PyObject_CallMethodId()", "_PyObject_GetAttrId()" and
  "_PyUnicode_FromId()" are deprecated since 3.15 and will be removed
  in 3.20. Instead, use "PyUnicode_InternFromString()" and cache the
  result in the module state, then call "PyObject_CallMethod()" or
  "PyObject_GetAttr()". Patch by Victor Stinner.

* gh-142163: Fix the "HAVE_THREAD_LOCAL" macro being defined without
  the "Py_BUILD_CORE" macro set after including "Python.h".

* gh-137422: 修复 "PyImport_AddModuleRef()" 中的 *free threading* 竞争
  条件问题。 在之前版本中对该函数的两次调用有可能返回两个不同对象，只
  有其中一个会被存储到 "sys.modules" 中。

* gh-141726: Add "PyDict_SetDefaultRef()" to the Stable ABI.

* gh-140042: 移除可能导致与多个子解释器一起使用时关闭 sqlite 连接的
  sqlite3_shutdown 调用。

* gh-141070: Add "PyUnstable_Object_Dump()" to dump an object to
  "stderr". It should only be used for debugging. Patch by Victor
  Stinner.

* gh-139165: Expose the functions "Py_SIZE()", "Py_IS_TYPE()" and
  "Py_SET_SIZE()" in the Stable ABI.


构建
----

* gh-131372: Add "LDVERSION" and "EXE" to the "base_interpreter" value
  of "build-details.json".

* gh-142454: 计算 JIT stencil 输入的摘要时，在将文件内容添加到哈希器之
  前按文件名对要哈希的文件进行排序。这确保了确定性的哈希输入从而产生确
  定性的哈希，与文件系统顺序无关。

* gh-131372: "build-details.py" will only be installed as part of the
  main install ("make install"). "make altinstall" will no longer
  include it.

* gh-142234: Allow "--enable-wasm-dynamic-linking" for WASI. While
  CPython doesn't directly support it so external/downstream users do
  not have to patch in support for the flag.

* gh-142050: Fixed a bug where JIT stencils produced on Windows
  contained debug data. Patch by Chris Eibl.

* gh-141808: 在 Windows 上的 PGO 构建场景中不会重复生成 jit stencil。

* gh-141926: "RUNSHARED" is no longer cleared when cross-compiling.
  Previously, "RUNSHARED" was cleared when cross-compiling, which
  breaks PGO when using "--enabled-shared" on systems where the cross-
  compiled CPython is otherwise executable (e.g., via transparent
  emulation).

* gh-141808: 运行 "make clean-retain-profile" 时保留生成的 JIT stencil
  。这样在使用配置文件引导优化 (PGO) 时就不会生成两次 stencil。这也允
  许分发者提供他们自己预构建的 JIT stencil。

* gh-141784: 修复在 32 位 Linux 上 "_remote_debugging_module.c" 的编译
  问题。 在系统头文件之前先包括 Python.h 以确保
  "_remote_debugging_module.c" 使用与 Python 相同的类型 (ABI)。 由
  Victor Stinner 编写补丁。

* gh-141172: Update to WASI SDK 29.

* gh-139707: Add configure option "--with-missing-stdlib-config=FILE"
  allows which distributors to pass a JSON configuration file
  containing custom error messages for missing *standard library*
  modules.

* gh-108819: Honor "--with-platlibdir" in the pure-Python standard
  library installation path, if "PLATLIBDIR" doesn't match the value
  used in "LIBDIR".


Python 3.15.0 alpha 2
=====================

*Release date: 2025-11-18*


Windows
-------

* gh-140849: Update bundled liblzma to version 5.8.1.


工具/示例
---------

* gh-141442: 现在 iOS testbed 可正确地处理包含空格的测试参数。

* gh-140702: 现在 iOS testbed app 将把 "GITHUB_ACTIONS" 环境变量暴露给
  被测试的 iOS app。

* gh-139198: Remove "Tools/scripts/checkpip.py" script.

* gh-139188: Remove "Tools/tz/zdump.py" script.


测试
----

* gh-140482: 保留并恢复 "stty echo" 的状态作为测试环境的一部分。

* gh-140082: 更新 "python -m test" 当启用彩色运行时设置
  "FORCE_COLOR=1" 这样基于该设置运行的带转发输出的 "unittest" 将使用彩
  色输出。

* gh-136442: 当 "unittest.TestCase.setUpClass()" 引发异常时使用退出码
  "1" 而不是 "5"


安全性
------

* gh-137836: 在 "html.parser.HTMLParser" 中增加对“纯文本”元素, RAWTEXT
  元素 "xmp", "iframe", "noembed" 和 "noframes"，以及可选的 RAWTEXT 元
  素 "noscript" 的支持。

* gh-136063: "email.message": 确保旧式 HTTP 形参解析为线性复杂度。 由
  Bénédikt Tran 编写补丁。

* gh-136065: 修复 "os.path.expandvars()" 中的二次幂复杂度问题。


库
--

* gh-141497: "ipaddress": 确保 "IPv4Network.hosts()" 和
  "IPv6Network.hosts()" 等方法总是返回一个迭代器。

* gh-140938: 现在当输入包含无穷大或 NaN 时 "statistics.stdev()" 和
  "statistics.pstdev()" 函数现在将引发 "ValueError"。

* gh-124111: 将 "_tkinter" 中的 Tcl 线程配置更新为假定线程在 Tcl 9 或
  更高版本中始终可用。

* gh-137109: "os.fork" 及有关分叉 API 对于 Linux 或 macOS 平台 API 返
  回一个进程中线程数量的常见场景不会再发出警告并且即使在
  "os.register_at_fork()" "after_in_parent=" 回调（重新）启动一个线程
  时返回的答案仍将为 1。

* gh-141314: 修复 "io.TextIOWrapper.tell()" 在读取带以单个回车符
  ("\r") 作为行结束符时的断言失败问题。

* gh-141311: 修复 assertion failure in "io.BytesIO.readinto()" 在读取
  位置超出 "io.BytesIO" 的容量时的断言失败和引发未定义行为问题。

* gh-87710: "mimetypes": Update mime type for ".ai" files to
  "application/pdf".

* gh-85524: Update "io.FileIO.readall", an implementation of
  "io.RawIOBase.readall()", to follow "io.IOBase" guidelines and raise
  "io.UnsupportedOperation" when a file is in "w" mode rather than
  "OSError"

* gh-141141: 修复 "base64.b85decode()" 的一个线程安全问题。 由 Benel
  Tayar 贡献。

* gh-141018: "mimetypes": Update ".exe", ".dll", ".rtf" and (when
  "strict=False") ".jpg" to their correct IANA mime type.

* gh-137969: 修复 "annotationlib.ForwardRef.evaluate()" 返回的
  "ForwardRef" 对象不随新的 globals 更新的问题。

* gh-75593: Add support of *path-like objects* and *bytes-like
  objects* in "wave.open()".

* gh-140797: 未写入文档的 "re.Scanner" 类现在禁止了在其词汇模式中包含
  捕获分组的正则表达式。 使用捕获分组的模式在之前会导致带有段错误的崩
  溃。 请改用非捕获分组 (?:...)。

* gh-125115: 重构了 "pdb" 的解析问题以便位置参数能够直观地传递。

* gh-140815: 现在 "faulthandler" 会检测帧或代码对象是否不可用或已释放
  。 由 Victor Stinner 编写补丁。

* gh-100218: 当 "socket.if_nametoindex()" 或 "socket.if_indextoname()"
  引发 "OSError" 时正确设置 "errno"。 由 Bénédikt Tran 编写补丁。

* gh-140734: "multiprocessing": 修正在检查临时套接字文件路径长度时偏差
  为一的错误。 由 Bénédikt Tran 编写补丁。

* gh-140873: Add support of non-*descriptor* callables in
  "functools.singledispatchmethod()".

* gh-140874: 将 ensurepip 中捆绑的 pip 版本提升至 25.3

* gh-140826: Now "winreg.HKEYType" objects are compared by their
  underlying Windows registry handle value instead of their object
  identity.

* gh-140808: The internal class "mailbox._ProxyFile" is no longer a
  parameterized generic.

* gh-140691: 在 "urllib.request" 中，当打开一个 FTP URL 的操作因无法建
  立数据连接而失败时，控制连接的套接字现在将关闭以避免
  "ResourceWarning"。

* gh-103847: 修复当取消由 "asyncio.create_subprocess_exec()" 或
  "asyncio.create_subprocess_shell()" 创建的进程时发生挂起的问题。 由
  Kumar Aditya 编写补丁。

* gh-137821: Convert "_json" module to use Argument Clinic. Patched by
  Yoonho Hann.

* gh-140790: Initialize all Pdb's instance variables in "__init__",
  remove some hasattr/getattr

* gh-140766: Add "enum.show_flag_values()" and "enum.bin" to
  "enum.__all__".

* gh-120057: 将 "os.reload_environ()" 添加到 "os.__all__" 中。

* gh-140741: Fix "profiling.sampling.sample()" incorrectly handling a
  "FileNotFoundError" or "PermissionError".

* gh-140228: 当没有全局模块缓存时避免在 "linecache" 中为冻结模块执行不
  必要的文件系统调用。

* gh-139946: Error and warning keywords in "argparse.ArgumentParser"
  messages are now colorized when color output is enabled, fixing a
  visual inconsistency in which they remained plain text while other
  output was colorized.

* gh-140590: 修复针对可能导致内部状态破坏和崩溃的
  "functools.partial.__setstate__()" 的参数检查。 由 Sergey Miryanov
  编写补丁。

* gh-125434: Windows 系统上在 "faulthandler" 中显示线程名称。 由
  Victor Stinner 编写补丁。

* gh-140634: 修复 "os.sched_param.__reduce__()" 中的一个引用计数程序缺
  陷。

* gh-140650: Fix an issue where closing "io.BufferedWriter" could
  crash if the closed attribute raised an exception on access or could
  not be converted to a boolean.

* gh-140633: 在加载打包为 Apple 框架的扩展模块时会忽略设置模块的
  "__file__" 属性时引发的 "AttributeError"。

* gh-140601: "xml.etree.ElementTree.iterparse()" now emits a
  "ResourceWarning" when the iterator is not explicitly closed and was
  opened with a filename. This helps developers identify and fix
  resource leaks. Patch by Osama Abdelkader.

* gh-140593: "xml.parsers.expat": 修复一个可能影响将
  "ElementDeclHandler()" 设为自定义的元素声明处理器的用户的内存泄漏问
  题。 由 Sebastian Pipping 编写补丁。

* gh-140607: 在 "io.RawIOBase.read()" 内部，验证由
  "io.RawIOBase.readinto()" 返回的字节计数是有效的（在所提供的缓冲区内
  部）。

* gh-138162: 修复 "logging.LoggerAdapter" 带有 "merge_extra=True" 没有
  *extra* 参数的问题。

* gh-140481: Improve error message when trying to iterate a Tk widget,
  image or font.

* gh-138774: 现在当处理没有指定源的 "ast.Interpolation" 节点时
  "ast.unparse()" 会生成完整的源代码。now generates full source code
  when handlingnodes that do not have a specified source.

* gh-140474: 修复当使用空 "str" 和 "u" 类型码创建数组时 "array.array"
  中的内存泄漏问题。

* gh-140448: Change the default of "suggest_on_error" to "True" in
  "argparse.ArgumentParser".

* gh-137530: "dataclasses" 通过将生成的源代码中内联的标注替换为关联到
  相应方法的 "__annotate__" 函数修复针对生成的 "__init__" 方法的标注。

* gh-140348: 修复了 Python 3.14.0 中当使用 "|" 运算符合并
  "typing.Union" 对象与不属于类型的对象时会引发错误的退化问题。

* gh-76007: "decimal": Deprecate "__version__" and replace with
  "decimal.SPEC_VERSION".

* gh-76007: Deprecate "__version__" from "imaplib". Patch by Hugo van
  Kemenade.

* gh-140272: 修复 "dbm.gnu" 数据库的 "clear()" 方法中的内存漏洞问题。

* gh-129117: "unicodedata": Add "isxidstart()" and "isxidcontinue()"
  functions to check whether a character can start or continue a
  Unicode Standard Annex #31 identifier.

* gh-140251: Colorize the default import statement "import asyncio" in
  asyncio REPL.

* gh-140212: Calendar's HTML formatting now accepts year and month as
  options. Previously, running "python -m calendar -t html 2025 10"
  would result in an error message. It now generates an HTML document
  displaying the calendar for the specified month. Contributed by Pål
  Grønås Drange.

* gh-135801: Improve filtering by module in "warnings.warn_explicit()"
  if no *module* argument is passed. It now tests the module regular
  expression in the warnings filter not only against the filename with
  ".py" stripped, but also against module names constructed starting
  from different parent directories of the filename (with
  "/__init__.py", ".py" and, on Windows, ".pyw" stripped).

* gh-139707: Improve "ModuleNotFoundError" error message when a
  *standard library* module is missing.

* gh-140041: 修复在 Android 和 Cygwin 上当存在 ABI 旗标时 "ctypes" 的
  导入问题。

* gh-140120: 修复 "hmac" 中当其使用 hacl-star 后端时的内存泄漏问题。
  由 "@ashm-dev" 使用 AddressSanitizer 发现。

* gh-140141: The "importlib.metadata.PackageNotFoundError" traceback
  raised when "importlib.metadata.Distribution.from_name" cannot
  discover a distribution no longer includes a transient
  "StopIteration" exception trace.

  Contributed by Bartosz Sławecki in gh-140142.

* gh-140166: "mimetypes": Per the IANA assignment, update the MIME
  type for the ".texi" and ".texinfo" file formats to
  "application/texinfo", instead of "application/x-texinfo".

* gh-140135: Speed up "io.RawIOBase.readall()" by using PyBytesWriter
  API (about 4x faster)

* gh-76007: "zlib": Deprecate "__version__" and schedule for removal
  in Python 3.20.

* gh-136702: "encodings": Deprecate passing a non-ascii *encoding*
  name to "encodings.normalize_encoding()" and schedule removal of
  support for Python 3.17.

* gh-139940: Print clearer error message when using "pdb" to attach to
  a non-existing process.

* gh-139462: When a child process in a
  "concurrent.futures.ProcessPoolExecutor" terminates abruptly, the
  resulting traceback will now tell you the PID and exit code of the
  terminated process. Contributed by Jonathan Berg.

* gh-63161: 修复 "tokenize.detect_encoding()" 的问题。 在指定了非
  UTF-8 编码格式时支持 UTF-8 shebang 和注释。 检测非 UTF-8 编码格式的
  解码错误。 检测源代码中的空字节。

* gh-101828: 修复 "'shift_jisx0213'", "'shift_jis_2004'",
  "'euc_jisx0213'" 和 "'euc_jis_2004'" 编解码器因为空字符被当作多字符
  串序列的一部分而截断它们的问题。

* gh-139246: 修正：在默认 repl 宽度中粘贴零宽度是错误的。

* gh-83714: Implement "os.statx()" on Linux kernel versions 4.11 and
  later with glibc versions 2.28 and later.  Contributed by Jeffrey
  Bosboom and Victor Stinner.

* gh-138891: 修复当在带有 **PEP 646** "star_expression" 标注的函数上调
  用 "inspect.get_annotations(f, eval_str=True)" 时的 "SyntaxError" 问
  题。

* gh-138859: 修复当省略具有不为类型列表的默认值的 "ParamSpec" 时泛型类
  型参数化引发 "TypeError" 的问题。

* gh-138764: 在具有空 globals 的模拟 globals 命名空间中避免
  "annotationlib.call_annotate_function()" 调用不支持
  "VALUE_WITH_FAKE_GLOBALS" 的 "__annotate__" 函数。

  让 "FORWARDREF" 和 "STRING" 标注在它们自己的格式或
  "VALUE_WITH_FAKE_GLOBALS" 均不受支持的情况下回退为使用 "VALUE" 标注
  。

* gh-138775: 修复对 "base64" 使用 "python -m" 时检测来自终端的输入问题
  以使其能正确感知 EOF。

* gh-98896: 修正当 SharedMemory 名称包含冒号时 multiprocessing
  resource_tracker 中的一个错误。 由 Rani Pinchuk 编写补丁。

* gh-138425: 修复依赖于定义为全局变量的名称的
  "annotationlib.ForwardRef" 对象的部分求值问题。

* gh-138151: 在 "annotationlib" 中，改进针对当标注被初始求值时尚未定义
  nonlocal 变量的前向引用的求值。

* gh-69528: The "mode" attribute of files opened in the "'wb+'" mode
  is now "'wb+'" instead of "'rb+'".

* gh-137627: Speed up "csv.Sniffer.sniff()" delimiter detection by up
  to 1.6x.

* gh-55531: "encodings": Improve "normalize_encoding()" performance by
  implementing the function in C using the private
  "_Py_normalize_encoding" which has been modified to make lowercase
  conversion optional.

* gh-136057: 修复了在 "pdb" 和 "bdb" 中如果行内存在循环则 "next" 和
  "step" 无法穿过该行的程序缺陷。

* gh-133390: Support table, index, trigger, view, column, function,
  and schema completion for "sqlite3"'s command-line interface.

* gh-135307: "email": 修正当 encoding 文本和 max_line_length 被设为
  "0" 或 "None" (无限制) 时在 "set_content()" 中引发异常的问题。

* gh-133789: 修正对在 Python 3.13 中封存的 "pathlib" 对象进行解封时存
  在的问题。

* gh-133601: Remove deprecated "typing.no_type_check_decorator()".

* gh-132686: Add parameters *inherit_class_doc* and
  *fallback_to_class_doc* for "inspect.getdoc()".

* gh-131116: "inspect.getdoc()" now correctly returns an inherited
  docstring on "cached_property" objects if none is given in a
  subclass.

* gh-130693: Add support for "-nolinestop", and "-strictlimits"
  options to "tkinter.Text.search()". Also add the
  "tkinter.Text.search_all()" method for "-all" and "-overlap"
  options.

* gh-122255: In the "linecache" module and in the Python
  implementation of the "warnings" module, a "DeprecationWarning" is
  issued when "mod.__loader__" differs from "mod.__spec__.loader"
  (like in the C implementation of the "warnings" module).

* gh-121011: "math.log()" now supports arbitrary large integer-like
  arguments in the same way as arbitrary large integer arguments.

* gh-119668: Publicly expose and document
  "importlib.machinery.NamespacePath".

* gh-102431: 在 "decimal.Context" 的方法中明确对“逻辑”参数的约束。

* gh-81313: Add the "math.integer" module (**PEP 791**).


核心与内置函数
--------------

* gh-141579: 修复 "sys.activate_stack_trampoline()" 以正确地支持
  "perf_jit" 后端。 由 Pablo Galindo 编写补丁。

* gh-114203: 如果对象已被双向互斥关键节锁定则跳过锁定操作。

* gh-141528: 当就其他子解释器发出警告时建议使用
  "concurrent.interpreters.Interpreter.close()" 而不是私有的
  "_interpreters.destroy" 函数。 由 Sergey Miryanov 编写补丁。

* gh-141367: Specialize "CALL_LIST_APPEND" instruction only for lists,
  not for list subclasses, to avoid unnecessary deopt. Patch by
  Mikhail Efimov.

* gh-141312: 修复在 range 迭代器的 "__setstate__" 方法中当传入非整数参
  数时的断言失败问题。 由 Sergey Miryanov 编写补丁。

* gh-140643: Add support for "<GC>" and "<native>" frames to
  "profiling.sampling" output to denote active garbage collection and
  calls to native code.


库
--

* gh-140942: Add ".cjs" to "mimetypes" to give CommonJS modules a MIME
  type of "application/node".


核心与内置函数
--------------

* gh-140479: Update JIT compilation to use LLVM 21 at build time.

* gh-140939: 修复当 "bytearray" 或 "bytes" 使用 "%*b" 格式以很大的宽度
  值进行格式化而导致 "MemoryError" 时的内存泄漏问题。


库
--

* gh-140260: 修复子解释器端序表初始化中的 "struct" 数据竞争问题。 由
  Shamil Abdulaev 编写补丁。


核心与内置函数
--------------

* gh-140530: 修复当 "raise exc from cause" 执行失败时的引用泄漏问题。
  由 Bénédikt Tran 编写补丁。


库
--

* gh-90344: Replace "io.IncrementalNewlineDecoder" with non
  incremental newline decoders in codebase where
  "io.IncrementalNewlineDecoder.decode()" was being called once.


核心与内置函数
--------------

* gh-140373: 当生成器对象关闭时正确发出 "PY_UNWIND" 事件。由 Mikhail
  Efimov 编写补丁。

* gh-140729: Fix pickling error in the sampling profiler when using
  "concurrent.futures.ProcessPoolExecutor" script can not be properly
  pickled and executed in worker processes.

* gh-131527: Dynamic borrow checking for stackrefs is added to
  "Py_STACKREF_DEBUG" mode. Patch by Mikhail Efimov.

* gh-140576: 修复 "tokenize.generate_tokens()" 在特定错误输入情况下的
  崩溃问题。 由 Mikhail Efimov 编写补丁。

* gh-140544: Speed up accessing interpreter state by caching it in a
  thread local variable. Patch by Kumar Aditya.

* gh-140551: 修复当 "dict.clear()" 在查找阶段被调用时 "dict" 中的崩溃
  问题。 由 Mikhail Efimov 和 Inada Naoki 编写补丁。

* gh-140517: 修复当输入的可迭代对象具有不同长度时在对设置了
  "strict=True" 的 "map()" 的结果进行迭代时的引用泄漏问题。 由 Mikhail
  Efimov 编写补丁。

* gh-133467: Fix race when updating "type.__bases__" that could allow
  a read of "type.__base__" to observe an inconsistent value on the
  free threaded build.

* gh-140471: 修复了在遇到包含非 "str" 的不良格式 "_fields" 时
  "ast.AST" 节点初始化中潜在的缓冲区溢出问题。


库
--

* gh-140443: The logarithm functions (such as "math.log10()" and
  "math.log()") may now produce slightly different results for
  extremely large integers that cannot be converted to floats without
  overflow. These results are generally more accurate, with reduced
  worst-case error and a tighter overall error distribution.


核心与内置函数
--------------

* gh-140431: 修复在 Python 的 *垃圾回收器* 中当协程原始跟踪深度
  ("sys.set_coroutine_origin_tracking_depth()") 被启用时由于部分初始化
  的 *coroutine* 对象导致的崩溃问题。

* gh-140476: Optimize "PySet_Add()" for "frozenset" in *free threaded*
  build.

* gh-135904: Add special labels to the assembly created during stencil
  creation to support relocations that the native object file format
  does not support. Specifically, 19 bit branches for AArch64 in
  Mach-O object files.


库
--

* gh-140398: 修复当 "PySys_Audit()" 执行失败时在 "readline" 的
  "read_init_file()", "read_history_file()", "write_history_file()" 和
  "append_history_file()" 函数中的内存泄漏问题。


核心与内置函数
--------------

* gh-140406: 修复当一个对象的 "__hash__()" 方法返回不为 "int" 的对象时
  发生崩溃的问题。

* gh-140358: 恢复在 GC 调试输出中的已花费时间和不可访问对象计数。 这些
  内容在 "gc.c" 重构期间被无意中移除了。 调试日志现在将再次报告已花费
  收集时间和不可访问对象数量。 由 Pål Grønås Drange 贡献。

* gh-136895: Update JIT compilation to use LLVM 20 at build time.

* gh-139109: A new tracing frontend for the JIT compiler has been
  implemented. Patch by Ken Jin. Design for CPython by Ken Jin, Mark
  Shannon and Brandt Bucher.

* gh-140306: 修复跨解释器通道操作和共享命名空间处理中的内存泄漏问题。

* gh-116738: Make _suggestions module thread-safe on the *free
  threaded* build.

* gh-140301: 修复子解释器中 "PyConfig" 的内存泄漏问题。

* gh-140257: 修复守护线程最终化期间在 eval_breaker 上
  interpreter_clear() 和 take_gil() 之间的数据竞争问题。

* gh-139951: 修复针对主要由小元组构成的堆不断增长导致的 GC 性能回归问
  题。

  * 实际跟踪对象，而非可跟踪对象的计数。 这将确保未跟踪的元组具有降低
    GC 开销的预期效果。

  * 不跟踪在创建期间大部分不可跟踪的元组。 这将避免大量小元组导致过度
    的 GC 操作。

* gh-140253: Wrong placement of a double-star pattern inside a mapping
  pattern now throws a specialized syntax error. Contributed by
  Bartosz Sławecki in gh-140253.

* gh-140104: 修复 JIT 中的一个异常处理程序缺陷。 由 Ken Jin 编写补丁。
  由 Daniel Diniz 报告程序缺陷。

* gh-140149: Speed up parsing bytes literals concatenation by using
  PyBytesWriter API and a single memory allocation (about 3x faster).

* gh-140061: 修正检查对象是否被唯一引用的功能以确保自由线程兼容性。 由
  Sergey Miryanov 编写补丁。

* gh-140080: Fix hang during finalization when attempting to call
  "atexit" handlers under no memory.

* gh-139871: Update "bytearray" to use a "bytes" under the hood as its
  buffer and add "bytearray.take_bytes()" to take it out.

* gh-140067: 修复子解释器创建中的内存泄漏问题。

* gh-139914: 恢复对 HP PA-RISC 的支持，它具有向上增长的栈。

* gh-139817: Attribute "__qualname__" is added to
  "typing.TypeAliasType". Patch by Mikhail Efimov.

* gh-135801: Many functions related to compiling or parsing Python
  code, such as "compile()", "ast.parse()", "symtable.symtable()", and
  "importlib.abc.InspectLoader.source_to_code()" now allow to specify
  the module name. It is needed to unambiguous filter syntax warnings
  by module name.

* gh-139640: "ast.parse()" 将不再针对 "finally" 中的
  "return"/"break"/"continue" 发出语法警告 (参见 **PEP 765**) -- 它们
  只会在编译期间发出。

* gh-139640: 修复在多个模块中当某些语法警告具有相同消息并从相同行发出
  时被漏掉的问题。 修复 "finally" 代码块中重复的警告。

* gh-139475: Changes in stackref debugging mode when
  "Py_STACKREF_DEBUG" is set. We use the same pattern of refcounting
  for stackrefs as in production build.

* gh-139269: Fix undefined behavior when using unaligned store in
  JIT's "patch_*" functions.

* gh-138944: 修复当无效的语法与有效的 "import ... as ..." 或 "from ...
  import ... as ..." 语句出现在同一行时的 "SyntaxError"。 由 Brian
  Schubert 编写补丁。

* gh-138857: Improve "SyntaxError" message for "case" keyword placed
  outside "match" body.

* gh-131253: Support the "--enable-pystats" build option for the free-
  threaded build.

* gh-136327: Errors when calling functions with invalid values after
  "*" and "**" now do not include the function name. Patch by Ilia
  Solin.

* gh-134786: If "Py_TPFLAGS_MANAGED_DICT" and
  "Py_TPFLAGS_MANAGED_WEAKREF" are used, then "Py_TPFLAGS_HAVE_GC"
  must be used as well.


C API
-----

* gh-141341: On Windows, rename the "COMPILER" macro to "_Py_COMPILER"
  to avoid name conflicts. Patch by Victor Stinner.

* gh-116146: Add a new "PyImport_CreateModuleFromInitfunc()" C-API for
  creating a module from a *spec* and *initfunc*. Patch by Itamar
  Oren.

* gh-141042: 当转换至较窄精度的浮点格式时，在 "PyFloat_Pack2()" 和
  "PyFloat_Pack4()" 中使用 qNaN --- 在截断载荷之后的剩余值将为零。 由
  Sergey B Kirpichev 编写补丁。

* gh-141004: "Py_MATH_El" and "Py_MATH_PIl" are deprecated.

* gh-141004: The "Py_INFINITY" macro is *soft deprecated*.

* gh-140556: **PEP 793**: Add a new entry point for C extension
  modules, "PyModExport_<modulename>".

* gh-140487: 修复受限 C API 3.11 或更早版本中的
  "Py_RETURN_NOTIMPLEMENTED": 不将 "Py_NotImplemented" 当作永生对象。
  由 Victor Stinner 编写补丁。

* gh-140153: 修复受限 C API 3.11-3.13 中的 "Py_REFCNT()" 定义。 由
  Victor Stinner 编写补丁。

* gh-139653: 增加 "PyUnstable_ThreadState_SetStackProtection()" 和
  "PyUnstable_ThreadState_ResetStackProtection()" 函数用于设置 Python
  线程状态的栈保护基准地址和栈保护大小。 由 Victor Stinner 编写补丁。


构建
----

* gh-140454: When building the JIT, match the jit_stencils filename
  expectations in Makefile with the generator script. This avoid
  needless JIT recompilation during "make install".

* gh-140768: 当 WASI SDK 版本与受支持版本不匹配时发出警告。

* gh-140513: 当 "_Py_TAIL_CALL_INTERP" 被启用但 "preserve_none" 或
  "musttail" 不受支持时生成明确的编译错误。

* gh-140475: Support WASI SDK 25.

* gh-140239: Check "statx" availability only on Linux (including
  Android).

* gh-140189: iOS 构建被添加到 CI。

* gh-137618: "PYTHON_FOR_REGEN" 现在需要 Python 3.10 至 Python 3.15。
  由 Adam Turner 编写补丁。


Python 3.15.0 alpha 1
=====================

*发布日期: 2025-10-14*


macOS
-----

* gh-115119: Update macOS installer to use libmpdecimal 4.0.1.

* gh-124111: Update macOS installer to use Tcl/Tk 9.0.2.

* gh-132339: Update macOS installer version of OpenSSL to 3.5.4.

* gh-137450: macOS 安装程序 shell 路径管理的改进：拆分安装程序的
  "Shell profile updater" 安装后脚本与 "Update Shell Profile.command"
  以启用更健壮的错误处理。

* gh-137134: 更新 macOS 安装程序以附带 SQLite 3.50.4 版。


Windows
-------

* gh-139810: 现在使用 "py install 3[.x]-dev" 安装时将会选择最终版本和
  预发布版本。

* gh-139573: 将捆绑的 OpenSSL 版本升级至 3.0.18。

* gh-138896: 修复在未更新的 Windows 机器上安装 C 运行时导致的错误

* gh-138314: Add "winreg.DeleteTree()".

* gh-137136: Suppress build warnings when build on Windows with "--
  experimental-jit-interpreter".

* gh-137134: 更新 Windows 安装程序以附带 SQLite 3.50.4。

* gh-135099: 修复了在 Windows 上当后台线程等待 "PyMutex" 而主线程正在
  关闭解释器时可能发生的崩溃。

* gh-130727: 修复了对 WMI 的内部调用中一个竞争问题，它可能在高负载情况
  下导致 "invalid handle（无效句柄）" 异常。 由 Chris Eibl 提供补丁。

* gh-76023: 使 "os.path.realpath()" 在非严格模式下忽略Windows错误1005
  。

* gh-133779: 撤销了根据编译器设置生成不同的 "pyconfig.h" 文件的更改，
  因为它经常导致扩展构建失败。特别是，当为实验性自由线程运行时编译时，
  "Py_GIL_DISABLED" 预处理器变量现在必须始终明确定义。
  "sysconfig.get_config_var()" 函数可用于确定当前运行时是否是用该标志
  编译的。

* gh-133626: 确保包不会意外捆绑到传统安装程序中。

* gh-133580: Fix "sys.getwindowsversion()" failing without setting an
  exception when called on some WinAPI partitions.

* gh-133572: Avoid LsaNtStatus to WinError conversion on unsupported
  WinAPI partitions.

* gh-133568: Fix compile error when using a WinAPI partition that
  doesn't support the RPC runtime library.

* gh-133562: Disable handling of security descriptors by "os.mkdir()"
  with mode "0o700" on WinAPI partitions that do not support it. This
  only affects custom builds for specialized targets.

* gh-133537: Avoid using console I/O in WinAPI partitions that don’t
  support it

* gh-131942: Use the Python-specific "Py_DEBUG" macro rather than
  "_DEBUG" in Windows-related C code. Patch by Xuehai Pan.


工具/示例
---------

* gh-139330: SBOM 生成工具不会针对 "Modules/expat/refresh.sh" 脚本交叉
  检查版本和校验和值，导致这些值在例程更新期间变得过时。

* gh-132006: XCframeworks 现在包括隐私声明以满足 Apple App Store 的提
  交要求。

* gh-138171: 增加一个用于构建 iOS XCframework 的脚本。 作为此项改变的
  一部分，最高层级的 "iOS" 文件夹被移动为 "Apple" 文件夹的子目录。

* gh-137873: iOS 测试运行器已简化，解决了在 GitHub Actions 和 Azure
  Pipelines 测试环境中使用该运行器时观察到的一些问题。

* gh-137484: 由 "Tools/wasm/wasi" 将构建的 Python 放入以 build 加三个
  数值而非 "build" 命名的目录。

* gh-137025: The "wasm_build.py" script has been removed.
  "Tools/wasm/emscripten" and "Tools/wasm/wasi" should be used
  instead, as described in the Dev Guide.

* gh-137248: 给 "Tools/wasm/wasi" 增加 "--logdir" 选项用来指明将日志文
  件写到何处。

* gh-137243: 当直接从发布 tarball 中提取文件时让 Tools/wasm/wasi 在
  /opt 中检测 WASI SDK 安装情况。

* gh-136251: 针对 "Tools/wasm/emscripten/web_example" 的修复与可用性改
  进

* gh-135968: 现在，"strip" 工具的存根文件已作为 iOS 安装包的一部分提供
  。

* gh-135379: The cases generator no longer accepts type annotations on
  stack items. Conversions to non-default types are now done
  explicitly in bytecodes.c and optimizer_bytecodes.c. This will
  simplify code generation for top-of-stack caching and other future
  features.

* gh-134215: *REPL* 导入自动补全仅在明确指定时才建议私有模块。


测试
----

* gh-139208: 修复 regrtest "--fast-ci --verbose": 不会再忽略 "--
  verbose" 选项。 由 Victor Stinner 编写补丁。

* gh-138313: Restore skipped test and add janky workaround to prevent
  select buildbots from failing with a ResourceWarning.

* gh-135966: iOS测试平台现在将 "app_packages" 文件夹作为站点目录处理。

* gh-135494: 修复regrtest以支持从 "--pgo" 测试中排除测试。由Victor
  Stinner提供补丁。

* gh-132815: 修复 test__opcode 测试：在特化统计中添加 "JUMP_BACKWARD"
  指令。

* gh-135489: 在使用 --enable-optimizations 时，为 PGO 分析步骤中失败的
  测试显示详细输出。

* gh-135401: Add a new GitHub CI job to test the "ssl" module with
  AWS-LC as the backing cryptography and TLS library.

* gh-135120: 添加 "test.support.subTests()"。

* gh-134567: Expose log formatter to users in TestCase.assertLogs.
  "unittest.TestCase.assertLogs()" will now optionally accept a
  formatter that will be used to format the strings in output if
  provided.

* gh-133744: 修复多进程中断测试。添加一个事件来同步父进程与子进程：等
  待直到子进程开始睡眠。由Victor Stinner提供补丁。

* gh-133682: 修复了测试用例
  "test.test_annotationlib.TestStringFormat.test_displays"，确保在字符
  串注释中正确处理复杂数据结构（列表、集合、字典和元组）。

* gh-133639: 修复 "TestPyReplAutoindent.test_auto_indent_default()" 不
  运行 "input_code" 的问题。


安全性
------

* gh-139700: 检测 zip64 中央目录记录末尾的一致性。 在没有字节数据被附
  加到 ZIP 文件时支持使用 "zip64 可扩展数据" 的记录。

* gh-139400: "xml.parsers.expat": 确保父级 Expat 解析器当其不再被
  "ExternalEntityParserCreate()" 所创建的子解析器所引用时只会被作为垃
  圾回收一次。 由 Sebastian Pipping 编写补丁。

* gh-139283: "sqlite3": 正确处理 "Cursor.fetchmany" 可获取的最大行数并
  拒绝 "Cursor.arraysize" 使用负值。 由 Bénédikt Tran 编写补丁。

* gh-136053: "marshal": 修复在反序列化 "slice" 对象时可能出现的崩溃。

* gh-135661: 根据HTML5标准修复 "html.parser.HTMLParser" 中开始和结束标
  签的解析。

  * 不再接受在 "</" 和标签名之间的空格。例如，"</ script>" 不会结束脚
    本部分。

  * 垂直制表符("\v")和非ASCII空格不再被识别为空白符。空白符只有
    "\t\n\r\f" 和空格。

  * 空字符(U+0000)不再结束标签名。

  * 现在会忽略结束标签中标签名后的属性和斜杠，而不再在带引号的属性值中
    的第一个 ">" 处终止解析。例如："</script/foo=">"/>"。

  * 现在在开始和结束标签中忽略最后一个属性和闭合 ">" 之间的多个斜杠和
    空白符。例如，"<a foo=bar/ //>"。

  * 属性名与属性值之间多个连续的 "=" 符号将不再被合并处理。例如："<a
    foo==bar>" 会生成属性名为 "foo"、属性值为 "=bar" 的标签。

* gh-135661: 根据 HTML5 标准修复了 "html.parser.HTMLParser" 中的 CDATA
  段解析问题："] ]>" 和 "]] >" 不再终止 CDATA 段。新增私有方法
  "_set_support_cdata()"，可用于指定如何解析 "<[CDATA[" —— 在外部内容
  （SVG 或 MathML）中作为 CDATA 段解析，或在 HTML 命名空间中作为伪注释
  解析。

* gh-102555: 根据HTML5标准修复 "html.parser.HTMLParser" 中的注释解析。
  "--!>" 现在结束注释。"-- >" 不再结束注释。支持异常结束的空注释
  "<-->" 和 "<--->"。

* gh-135462: 修复 "html.parser.HTMLParser" 在处理特制输入时的二次方复
  杂度问题。现根据HTML5规范处理文件结束错误——自动闭合注释和声明，忽略
  标签。

* gh-118350: 修复 "html.parser.HTMLParser" 对可转义原始文本模式（
  "textarea" 和 "title" 元素）的支持问题。

* gh-135034: 修复了多个问题，这些问题允许使用精心构造的符号链接和硬链
  接绕过 "tarfile" 提取过滤器 ("filter="data"" 和 "filter="tar"")。

  解决了 **CVE 2024-12718**、**CVE 2025-4138**、**CVE 2025-4330** 和
  **CVE 2025-4517**。

* gh-133767: 修复在非"严格"错误处理程序中使用"unicode-escape"解码器时
  的释放后使用问题。

* gh-133623: Indicate through "ssl.HAS_PSK_TLS13" whether the "ssl"
  module supports "External PSKs" in TLSv1.3, as described in RFC
  9258. Patch by Will Childs-Klein.

* gh-128840: 在 "ipaddress" 中早期短路处理长IPv6地址，以防止过多的内存
  消耗和轻微的拒绝服务。


库
--

* gh-139482: Optimize "os.environ.clear()" by calling *clearenv(3)*
  when this function is available. Patch by Victor Stinner.

* gh-139958: The "application/toml" mime type is now supported by
  "mimetypes". Patch by Gil Forcada.

* gh-139823: "ensurepip" now fails with a nicer error message when the
  "zlib" module is not available.

* gh-139905: 当 "cls.__parameters__" 由于父类在其 "__init_subclass__"
  中调用 "super().__init_subclass__()" 失败时为 "typing.Generic" 子类
  的错误消息添加提示。

* gh-139894: 修复在 "asyncio" 内进行分叉时不正确的当前任务与子进程的共
  享。 由 Kumar Aditya 编写补丁。

* gh-139845: 在默认 asyncio REPL 中修正为不再打印 KeyboardInterrupt 两
  次。

* gh-139783: 修正当一个装饰器后面跟一条注释或一个空行时
  "inspect.getsourcelines()" 的问题。

* gh-139809: 防止对 "argparse.ArgumentParser.add_subparsers()" 中的子
  解析器 "prog" 过早着色以遵守在解析器创建之后色彩环境变量的修改。

* gh-139736: 修复默认 "argparse" "HelpFormatter" 中的过度缩进。 由
  Alexander Edland 编写补丁。

* gh-70765: "http.server": 修复 "BaseHTTPRequestHandler" 中对 HTTP/0.9
  请求的默认处理。 在之前版本中，
  "BaseHTTPRequestHandler.parse_request()" 会不正确地等待请求中的标头
  虽然它们在 HTTP/0.9 并不被支持。 由 Bénédikt Tran 编写补丁。

* gh-139322: Fix "os.getlogin()" error handling: fix the error number.
  Patch by Victor Stinner.

* gh-135953: Add a Gecko format output to the tachyon profiler via "--
  gecko".

* gh-139184: "os.forkpty()" does now make the returned file descriptor
  non-inheritable.

* gh-139391: 修复在非 Windows 平台上，当无法正常退出用 Ctrl+Z 挂起随后
  再由 *fg* 恢复而不是 *kill* 的 "python -m asyncio" 进程时会出现的问
  题。

* gh-139374: "timeit": Add color to error tracebacks.

* gh-90949: Add
  "SetBillionLaughsAttackProtectionActivationThreshold()" and
  "SetBillionLaughsAttackProtectionMaximumAmplification()" to
  xmlparser objects to tune protections against billion laughs
  attacks. Patch by Bénédikt Tran.

* gh-139312: 将捆绑的 libexpat 升级至 2.7.3

* gh-139289: 在 "pdb" 的 "rlcompleter" 上执行真正的惰性导入并在导入
  "rlcompleter" 之后现有的 completer。

* gh-90949: Add "SetAllocTrackerActivationThreshold()" and
  "SetAllocTrackerMaximumAmplification()" to xmlparser objects to tune
  protections against disproportional amounts of dynamic memory usage
  from within an Expat parser. Patch by Bénédikt Tran.

* gh-67795: Functions that take timestamp or timeout arguments now
  accept any real numbers (such as "Decimal" and "Fraction"), not only
  integers or floats, although this does not improve precision.

* gh-95953: A CSS class, "diff_changed", was added to the changed
  lines in the "make_table" output of "difflib.HtmlDiff". Patch by
  Katie Gardner.

* gh-139210: 修复当在 "xml.etree.ElementTree.iterparse()" 中报告未知事
  件时的释放后使用问题。 由 Ken Jin 编写补丁。

* gh-138860: 在 "pdb" 中惰性导入 "rlcompleter" 以避免在子进程中发生死
  锁。

* gh-112729: 修复当进程内存不足时调用
  "concurrent.interpreters.create()" 的崩溃问题。

* gh-126016: Fix an assertion failure when sending "KeyboardInterrupt"
  to a Python process running a subinterpreter in a separate thread.

* gh-118803: "collections.abc.ByteString" has been removed from
  "collections.abc.__all__", and "typing.ByteString" has been removed
  from "typing.__all__". The former has been deprecated since Python
  3.12, and the latter has been deprecated since Python 3.9. Both
  classes are scheduled for removal in Python 3.17.

  Additionally, the following statements now cause
  "DeprecationWarning"s to be emitted at runtime: "from
  collections.abc import ByteString", "from typing import ByteString",
  "import collections.abc; collections.abc.ByteString" and "import
  typing; typing.ByteString". Both classes already caused
  "DeprecationWarning"s to be emitted if they were subclassed or used
  as the second argument to "isinstance()" or "issubclass()", but they
  did not previously lead to "DeprecationWarning"s if they were merely
  imported or accessed from their respective modules.

* gh-135729: 修复当在 REPL 中使用 "concurrent.interpreters" 时执行最终
  化期间不可引发的异常问题。

* gh-139076: 修复 "pydoc" 模块中当一个Python 模块内的函数是在扩展模块
  中实现并且该模块没有 "__all__" 时会将其隐藏的程序缺陷。

* gh-139090: Add "os.RWF_DONTCACHE" constant for Linux 6.14+.

* gh-139065: 修复 "textwrap" 中当行长度恰好为 *width* 时被折行的长单词
  之前的行尾空格问题。

* gh-139001: 修复在内部 "_raw_paths" 字段上 "pathlib.Path" 中的竞争条
  件问题。

* gh-138813: "multiprocessing.BaseProcess" 将 "kwargs" 默认为 "None"
  而不是一个共享字典。

* gh-138998: 将捆绑的 libexpat 更新至 2.7.2

* gh-138993: 撤销 "credits" 文本的缩进。text.

* gh-118803: 重新添加 "collections.abc.ByteString" 和
  "typing.ByteString"。这两个类在 Python 3.14 的 alpha、beta 和候选版
  本中已被移除，但现在它们的移除计划已推迟至 Python 3.17。

* gh-130567: 修复由于 macOS 上存在一个平台程序缺陷而可能在
  "locale.strxfrm()" 发生的崩溃问题。

* gh-137226: 修复了在带有字符串注解的泛型 "typing.TypedDict" 类上调用
  "typing.get_type_hints()" 的问题。

* gh-138899: Executing "quit" command in "pdb" will raise
  "bdb.BdbQuit" when "pdb" is started from an asyncio console using
  "breakpoint()" or "pdb.set_trace()".

* gh-138804: 当向 "shlex.quote()" 传递类型错误的参数时，将引发
  "TypeError" 而非 "AttributeError"。此变更恢复了该函数在 3.14 版本之
  前的行为。

* gh-138779: 针对 "os.stat_result" 结构体的 "st_rdev" 字段支持大于
  "2**63-1" 的设备号。

* gh-138682: Added symmetric difference support to
  "collections.Counter" objects.

* gh-138712: Add "os.NODEV".

* gh-128636: 修复了macOS 平台在 PyREPL 中当 "os.environ" 被覆盖为无效
  值时导致的崩溃问题。

* gh-138720: Fix an issue where "io.BufferedWriter" and
  "io.BufferedRandom" had different definitions of "closed" for
  "close()" and "flush()" which resulted in an exception when close
  called flush but flush thought the file was already closed.

* gh-138706: Update "unicodedata" database to Unicode 17.0.0.

* gh-76007: Deprecate "__version__" from a number of standard library
  modules. Patch by Hugo van Kemenade.

* gh-138535: Speed up "os.stat()" for files with reasonable
  timestamps. Contributed by Jeffrey Bosboom.

* gh-116946: "curses.panel": the type of "curses.panel.new_panel()" is
  now immutable. Patch by Bénédikt Tran.

* gh-116946: "zlib": the types of "zlib.compressobj()" and
  "zlib.decompressobj()" are now immutable. Patch by Bénédikt Tran.

* gh-116946: "os": the "os.DirEntry" type and the type of
  "os.scandir()" are now immutable. Patch by Bénédikt Tran.

* gh-116946: "tkinter": the types "_tkinter.Tcl_Obj" (wrapper for Tcl
  objects), "_tkinter.tktimertoken" (obtained by calling
  "createtimerhandler()" on a "Tk" application) and "_tkinter.tkapp"
  (the runtime type of Tk applications) are now immutable. Patch by
  Bénédikt Tran.

* gh-138514: 当将多字符字符串传给 "getpass.getpass()" 的 *echo_char*
  形参时将引发 "ValueError"。 由 Benjamin Johnson 编写补丁。

* gh-137706: 修复使用 "typing.Annotated[T, x]" 的标注部分求值问题，其
  中 "T" 是一个前向引用。

* gh-88375: 在 "urllib.robotparser" 模块中修复 "robots.txt" 规则和 URL
  的正规化问题。 不会再忽略末尾的 "?"。 对原始特殊字符 "?", "=" 和 "&"
  与其百分号编码形式进行区分。

* gh-138515: 向 Emscripten 构建版添加了 "email"。

* gh-99948: "ctypes.util.find_library()" 现在可用于 Emscripten 构建版
  。

* gh-111788: 修复 "urllib.robotparser" 模块中的解析错误。 尝试解析怪异
  路径时不会失败。 尝试解码非 UTF-8 的 "robots.txt" 文件时不会失败。

* gh-138432: 现在 "zoneinfo.reset_tzpath()" 会将它接收到的任何
  "os.PathLike" 对象在将其添加到 "TZPATH" 之前转换为字符串。 如果在此
  转换之后发现任何字符串以外的对象则将引发 "TypeError"。 如果给出一个
  代表相对路径的 "os.PathLike" 对象，则将引发 "ValueError" 而不是
  "TypeError"，并提供更详细的错误消息。

* gh-132657: Improve the scaling of "copy.copy()" and
  "copy.deepcopy()" in the free-threading build.

* gh-116946: The types of "select.poll()" and "select.epoll()" objects
  are now immutable. Patch by Bénédikt Tran.

* gh-116946: The "_random.Random" C type is now immutable. Patch by
  Bénédikt Tran.

* gh-57911: When extracting tar files on Windows, slashes in symlink
  targets will be replaced by backslashes to prevent corrupted links.

* gh-138205: Removed the "resize()" method on platforms that don't
  support the underlying syscall, instead of raising a "SystemError".

* gh-138008: 修复 "ctypes" 模块中由于无效的 "argtypes" 而导致的段错误
  。 由 Dung Nguyen 编写补丁。

* gh-138252: "ssl": "SSLContext" objects can now set client and server
  TLS signature algorithms. If Python has been built with OpenSSL 3.5
  or later, "SSLSocket" objects can return the signature algorithms
  selected on a connection.

* gh-138253: 在 "concurrent.interpreters" 队列的 "put()" 和 "get()" 方
  法中添加了 *block* 形参，以实现与 "queue.Queue" 接口的兼容性。

* gh-60462: 修复 Solaris 中的 "locale.strxfrm()" 问题（可能也存在于其
  他平台）。

* gh-138239: 现在 REPL 会将 "type" 作为 type 语句 中的软关键字高亮显示
  。

* gh-78502: "mmap.mmap" now has a *trackfd* parameter on Windows; if
  it is "False", the file handle corresponding to *fileno* will not be
  duplicated.

* gh-138204: 在 Linux 和禁止扩展共享匿名 "内存地图"，因为这会导致总线
  错误。

* gh-138010: 修复一个当使用以 "@warnings.deprecated" 装饰的基类定义的
  类在涉及多重继承的情况下可能不会唤起正确的 "__init_subclass__()" 方
  法的问题。 由 Brian Schubert 编写补丁。

* gh-134716: Add support of regular expressions in the "-W" option and
  the "PYTHONWARNINGS" environment variable.

* gh-138133: 修复了通过 "strace" 向 Python 发送 CTRL^C 时可能导致无限
  回溯循环的问题。

* gh-138122: Implement **PEP 799** -- A dedicated profiling package
  for organizing Python profiling tools. Patch by Pablo Galindo.

* gh-138092: Fixed a bug in "mmap.mmap.flush()" where calling with
  only an offset parameter would fail.

* gh-138044: Remove compatibility shim for deprecated parameter
  *package* in "importlib.resources.files()". Patch by Semyon Moroz.

* gh-86819: "socket": Add missing constants for ISO-TP sockets.

* gh-137884: Add "threading.get_native_id()" support for
  Illumos/Solaris. Patch by Yüce Tekol.

* gh-134869: 修复了一个问题，即在 REPL 中进行选项卡补全时按下 Ctrl+C
  会导致自动补全菜单处于损坏状态。

* gh-137840: "typing.TypedDict" now supports the "closed" and
  "extra_items" keyword arguments (as described in **PEP 728**) to
  control whether additional non-required keys are allowed and to
  specify their value type.

* gh-132947: Applied changes to "importlib.metadata" from
  importlib_metadata 8.7, including "dist" now disallowed for
  "EntryPoints.select"; deferred imports for faster import times;
  added support for metadata with newlines (python/cpython#119650);
  and "metadata()" function now returns "None" when a metadata
  directory is present but no metadata is present.

* gh-90548: 在 Alpine Linux  上修复当使用 --strip-all 编译时对
  "platform.libc_ver()" 的 "musl" 检测问题。

* gh-137317: "inspect.signature()" 现在能够正确处理在包装的
  "__init__()" 或 "__new__()" 方法上使用描述器的类。 由 Yongyu Yan 贡
  献。

* gh-137754: 修复当 "datetime" 模块的 C 实现不可用时 "zoneinfo" 模块的
  导入问题。

* gh-125854: Improve error messages for invalid category in
  "warnings.warn()".

* gh-137729: "locale.setlocale()" now supports language codes with
  "@"-modifiers. "@"-modifier are no longer silently removed in
  "locale.getlocale()", but included in the language code.

* gh-73487: Speedup processing arguments (up to 1.5x) in the "decimal"
  module methods, that now using "METH_FASTCALL" calling convention.
  Patch by Sergey B Kirpichev.

* gh-137634: Calendar pages generated by the "calendar.HTMLCalendar"
  class now support dark mode and have been migrated to the HTML5
  standard for improved accessibility.

* gh-137630: The "_interpreters" module now uses Argument Clinic to
  parse arguments. Patch by Adam Turner.

* gh-137583: Fix a deadlock introduced in 3.13.6 when a call to
  "ssl.SSLSocket.recv" was blocked in one thread, and then another
  method on the object (such as "ssl.SSLSocket.send") was subsequently
  called in another thread.

* gh-92936: Update regex used by "http.cookies.SimpleCookie" to handle
  values containing double quotes.

* gh-137426: 移除了 "importlib.abc.ResourceLoader" 的代码弃用。 它在文
  档中已被宣布弃用，但与 "importlib.abc" 中的其他类一起被保留用于向下
  兼容。

* gh-137490: 在 NetBSD 上以与 "signal.sigwaitinfo()" 中的 "EINTR" 相同
  的方式处理 "ECANCELED"。

